<?php

/**
 * Plugin Name: Cloud Edu2Work
 * Plugin URI: https://edu2work.com/wp-content/uploads/cloud-edu2work.zip
 * Description: Backup all files and restore as need includes database. Upload to cloud storage free upto <strong>2GB</strong>. <strong>Auto Backup</strong> daily when page access. Moreover, Upload your <strong>Media</strong> to cloud Storage include.
 * Version: 1.1.6
 * Author: Team EDU Work
 * Author URI: https://edu2work.com/
 * License: GPLv2
 */

$dir_backup_data = ABSPATH . 'wp-content/backup-file-edu2work';
if (!file_exists($dir_backup_data)) {
    mkdir($dir_backup_data);
}

$dir_plugins = ABSPATH . 'wp-content/backup-file-edu2work/old-plugins';
if (!file_exists($dir_plugins)) {
    mkdir($dir_plugins);
}

$dir_themes = ABSPATH . 'wp-content/backup-file-edu2work/old-themes';
if (!file_exists($dir_themes)) {
    mkdir($dir_themes);
}

$dir_uploads = ABSPATH . 'wp-content/backup-file-edu2work/old-uploads';
if (!file_exists($dir_uploads)) {
    mkdir($dir_uploads);
}
$version = '1.1.6';

define('API_URL1', 'https://api.toidayhoc.com');
define('API_URL2', 'https://api2.toidayhoc.com');
define('API_URL3', 'https://api.edu2work.com');
define('BACKUP_MENU', content_url());
define('BACKUP_DATA', $dir_backup_data . '/');
define('BACKUP_FILE', ABSPATH . 'wp-content/plugins/cloud-edu2work/settings/');
define('BACKUP_PATH', plugin_dir_path(__FILE__));
define('BACKUP_CHANGE', str_replace('\\', '/', plugin_dir_path(__FILE__)));
define('BACKUP_INCLUDES', dirname(__FILE__) . '/setting/includes/');
define('BACKUP_ASSETS', plugins_url('settings/assets/', __FILE__));
define('BACKUP_PLUGINS', $dir_plugins . '/');
define('BACKUP_THEMES', $dir_themes . '/');
define('BACKUP_UPLOADS', $dir_uploads . '/');
define('OLD_PLUGINS', $dir_plugins);
define('OLD_THEMES', $dir_themes);
define('OLD_UPLOADS', $dir_uploads);
define('BACKUP_VERSION', $version);


if (file_exists(BACKUP_PATH . 'vendor/autoload.php')) {
    require_once BACKUP_PATH . 'vendor/autoload.php';
}
if (file_exists(BACKUP_PATH . 'view.php')) {
    require_once BACKUP_PATH . 'view.php';
}

if (file_exists(BACKUP_PATH . 'settings/ajax.php')) {
    require_once BACKUP_PATH . 'settings/ajax.php';
}

if (file_exists(BACKUP_PATH . 'settings/UploadMedia.php')) {
    require_once BACKUP_PATH . 'settings/UploadMedia.php';
}

function backup_script()
{
    if (isset($_GET['page']) && $_GET['page'] == 'edu2work-admin') {
        wp_enqueue_script('axios', 'https://cdn.jsdelivr.net/npm/axios@0.24.0/dist/axios.min.js', array(), null, false);
        wp_enqueue_script('ajax', 'https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js', array(), null, false);
        wp_enqueue_script('sweetalert2', 'https://cdn.jsdelivr.net/npm/sweetalert2@11.0.19/dist/sweetalert2.min.js', array(), null, false);
        wp_enqueue_style('sweetalert2', 'https://cdn.jsdelivr.net/npm/sweetalert2@11.0.19/dist/sweetalert2.min.css', array(), null);
        wp_enqueue_script('bootstrap', 'https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/js/bootstrap.min.js', array('jquery'), null, false);
        wp_enqueue_style('bootstrap', 'https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/css/bootstrap.min.css', array(), null);
        wp_enqueue_style('bootstrap-icon', 'https://cdn.jsdelivr.net/npm/bootstrap-icons@1.11.2/font/bootstrap-icons.min.css', array(), null);
        wp_enqueue_script('fontawesome', 'https://kit.fontawesome.com/1330f21d64.js', array(), null);

        wp_enqueue_script('Backup', BACKUP_ASSETS . 'index.js', array('jquery'), BACKUP_VERSION, false);
        wp_enqueue_script('Backup-menu', BACKUP_ASSETS . 'menu.js', array('jquery'), BACKUP_VERSION, false);
        wp_enqueue_script('Backup-cloud', BACKUP_ASSETS . 'cloud.js', array('jquery'), BACKUP_VERSION, false);
        wp_enqueue_script('Backup-clone', BACKUP_ASSETS . 'clone.js', array('jquery'), BACKUP_VERSION, false);
        wp_enqueue_script('Backup-file', BACKUP_ASSETS . 'file.js', array('jquery'), BACKUP_VERSION, false);
        wp_enqueue_script('Backup-tool', BACKUP_ASSETS . 'tool.js', array('jquery'), BACKUP_VERSION, false);

        wp_enqueue_style('Backup', BACKUP_ASSETS . 'css/main.css', array(), BACKUP_VERSION, false);
        wp_enqueue_style('Backup-file', BACKUP_ASSETS . 'css/file.css', array(), BACKUP_VERSION, false);
        wp_localize_script('Backup', 'Backup_obj', array('ajaxurl' => admin_url('admin-ajax.php')));
        wp_localize_script('Backup', 'Backup_obj', array('img' => plugins_url('edu2work/img')));
        $api_key = get_option('md_edu_key');
        if (!$api_key) {
            wp_enqueue_script('login', BACKUP_ASSETS . 'login.js', array('jquery'), BACKUP_VERSION, false);
            wp_enqueue_style('MC', BACKUP_ASSETS . 'css/main.css', array(), BACKUP_VERSION, false);
            wp_localize_script('login', 'login_obj', array('ajaxurl' => admin_url('admin-ajax.php')));
        }

        add_action('admin_notices', 'welcome_edu2work');
        function welcome_edu2work()
        {
            $message = '<b>Greetings to Cloud Edu2Work!</b> Simply click on "Backup Now" to get your backup and experience how it work.';
            $class = 'notice notice-info is-dismissible';
            printf(
                '<div class="%1$s"><p>%2$s</p></div>',
                esc_attr($class),
                wp_kses($message, array('b' => array()))
            );
        }


        //Notification Cloud Storage
        if (get_option('md_edu_key')) {
            require_once BACKUP_FILE . 'get_size.php';
            require_once BACKUP_FILE . 'function.php';
            // Cron notification
            // add_action('admin_notices', 'wp_cron_status_notification');
            // function wp_cron_status_notification()
            // {
            //     if (defined('DISABLE_WP_CRON') && DISABLE_WP_CRON === true) {
            //         $message = "<b>Cloud Edu2Work:</b> The DISABLE_WP_CRON constant is set to true. Auto Backup is disabled. Please set DISABLE_WP_CRON to false in wp-config.php to run Auto Backup daily.";
            //         $class = 'notice notice-warning is-dismissible';
            //         printf(
            //             '<div class="%1$s"><p>%2$s</p></div>',
            //             esc_attr($class),
            //             wp_kses($message, array('b' => array()))
            //         );
            //     }
            // }
            // Hook into the admin_notices action
            add_action('admin_notices', 'custom_notification_edu');

            // Callback function for displaying the notification
            function custom_notification_edu()
            {
                // Generate the notification message
                $notification_message = 'Your Cloud Storage is reaching limit. Auto backup daily will be disabled. Contact us to Upgrade.';
                $success_msg = 'Your Cloud Storage used: ';
                $warning_msg = 'Your Cloud Storage neary full. Auto backup daily might be deactivated. Contact us to Upgrade.';
                $remain = remain_cloud();
                $allow = allow_cloud();
                $used = used_cloud();
                $limit = limit_cloud();
                $percent = number_format(($used / $limit) * 100, 1);  // Calculate the percentage
                // Output the notification HTML
                if ($remain) {
                    if ($percent > 96) {
                        echo '<div class="notice notice-error is-dismissible" style="display:flex; align-items:center">';
                        echo '<p style="font-weight:bold">Cloud Edu2Work:</p>';
                        echo '<p class="">' . esc_html($notification_message) . '</p>';
                        echo '<div class="" style="height:100%; width:20%; background:#e9ecef; margin:.5em; border-radius:0px; background-color: #f0f0f0; overflow: hidden;" >';
                        echo '<div class="" style="width: ' . $percent . '%; height: 8px; background-color: rgb(214, 0, 0); border-radius:0px"></div>';
                        echo '</div>';
                        echo '<p class="">' . $percent . '%</p>';
                        echo '<p class="">(' . size_convert_edu($used) . ' / ' . size_convert_edu($limit) . ')</p>';
                        echo '</div>';
                    } elseif ($percent > 85) {
                        echo '<div class="notice notice-warning is-dismissible" style="display:flex; align-items:center">';
                        echo '<p style="font-weight:bold">Cloud Edu2Work:</p>';
                        echo '<p class="">' . esc_html($warning_msg) . '</p>';
                        echo '<div class="" style="height:100%; width:20%; background:#e9ecef; margin:.5em; border-radius:0px; background-color: #f0f0f0; overflow: hidden;" >';
                        echo '<div class="" style="width: ' . $percent . '%; height: 8px; background-color: #dba617; border-radius:0px"></div>';
                        echo '</div>';
                        echo '<p class="">' . $percent . '%</p>';
                        echo '<p class="">(' . size_convert_edu($used) . ' / ' . size_convert_edu($limit) . ')</p>';
                        echo '</div>';
                    } else {
                        echo '<div class="notice notice-success is-dismissible" style="display:flex; align-items:center">';
                        echo '<p style="font-weight:bold">Cloud Edu2Work:</p>';
                        echo '<p class="">' . esc_html($success_msg) . '</p>';
                        echo '<div class="" style="height:100%; width:20%; background:#e9ecef; margin:.5em; border-radius:0px; background-color: #f0f0f0; overflow: hidden;" >';
                        echo '<div class="" style="width: ' . $percent . '%; height: 8px; background-color: #04AA6D; border-radius:0px"></div>';
                        echo '</div>';
                        echo '<p class="">' . $percent . '%</p>';
                        echo '<p class="">(' . size_convert_edu($used) . ' / ' . size_convert_edu($limit) . ')</p>';
                        echo '</div>';
                    };
                }
            }
        }
    }
    last_resort_enqueue_scripts();
}
add_action('admin_enqueue_scripts', 'backup_script');

function last_resort_enqueue_scripts()
{
    if (get_option('md-cloud-link')) {
        wp_enqueue_script('last_resort', BACKUP_ASSETS . '404src.js', array(), BACKUP_VERSION, false);
        wp_localize_script('last_resort', 'last_resort_obj', array('linkCloud' => get_option('md-cloud-link')));
    }
}

add_action('wp_enqueue_scripts', 'last_resort_enqueue_scripts');

add_filter('plugin_action_links_' . plugin_basename(__FILE__), 'add_action_links_backup_cloud');
function add_action_links_backup_cloud($actions)
{
    $mylinks = array(
        '<a href="' . admin_url('admin.php?page=edu2work-admin') . '">Settings</a>',
    );
    $actions = array_merge($actions, $mylinks);
    return $actions;
}
//Create table in db

// For admin
function auto_backup_admin()
{
    wp_enqueue_script('auto_backup', BACKUP_ASSETS . 'auto.js', array('jquery'), BACKUP_VERSION, false);
    wp_localize_script('Backup', 'Backup_obj', array('ajaxurl' => admin_url('admin-ajax.php')));
}
add_action('admin_enqueue_scripts', 'auto_backup_admin');

add_action('init', 'schedule_daily_cron_edu2work');
function schedule_daily_cron_edu2work()
{
    if (!wp_next_scheduled('daily_cron_event_edu2work')) {
        wp_schedule_event(time(), 'daily', 'daily_cron_event_edu2work');
    }
}

add_action('daily_cron_event_edu2work', 'run_daily_cron_edu2work');

function run_daily_cron_edu2work()
{
    // Include your PHP file here
    include_once BACKUP_FILE . 'auto.php';
    // include_once BACKUP_FILE . 'auto_delete.php';
    auto_backup();
    // auto_delete();
}

function overlay_edu2work()
{
    global $pagenow;
    if ($pagenow === 'upload.php') {
        wp_enqueue_script('overlay_edu', BACKUP_ASSETS . 'overlay.js', array('jquery'), BACKUP_VERSION, false);
        wp_localize_script('overlay_edu', 'crawl_post_obj', array('ajaxurl' => admin_url('admin-ajax.php')));
    }
}
add_action('admin_enqueue_scripts', 'overlay_edu2work');

// TODO: Add this in version 2
// if(get_option('md-cloud-link') != API_URL2) {
// 	$oldApi = get_option('md-cloud-link');
// 	global $wpdb;
//     $tablePrefix = $wpdb->prefix;

//     $attachmentsTable = $tablePrefix . 'posts';

//     $sql = "UPDATE $attachmentsTable SET guid = REPLACE(guid, %s, %s) WHERE post_type = %s";
//     $wpdb->query($wpdb->prepare($sql, $oldApi, API_URL1 . '/', 'attachment'));
// 	update_option('md-cloud-link', API_URL2);
// }

require_once plugin_dir_path(__FILE__) . 'plugin-update-checker-master/plugin-update-checker.php';

use YahnisElsts\PluginUpdateChecker\v5\PucFactory;

$myUpdateChecker = PucFactory::buildUpdateChecker(
    'https://edu2work.com/wp-content/uploads/update-cloud-edu2work.json',
    __FILE__,
    'Cloud_Edu2Work',
);
