<?php

if (get_option('md-status') == 1) {
    $UM_class = new UploadMedia();
    add_filter('wp_calculate_image_srcset', array($UM_class, 'mc_custom_image_srcset'), 10, 5);

    add_action('wp_ajax_upload_files', array($UM_class, 'upload_files'), 10, 2);
    add_action('wp_ajax_nopriv_upload_files', array($UM_class, 'upload_files'), 10, 2);
    add_filter('wp_handle_upload', array($UM_class, 'upload_files'), 10, 2);
    add_filter('wp_insert_attachment_data', array($UM_class, 'modify_attachment_data'), 10, 2);
    add_filter('wp_generate_attachment_metadata', array($UM_class, 'modify_attachment_metadata'), 10, 2);


    add_filter('wp_get_attachment_url', array($UM_class, 'mc_custom_attachment_url'), 10, 2);

    add_action('wp_ajax_get_file_media_cloud', array($UM_class, 'get_file_media_cloud'));
    add_action('wp_ajax_nopriv_get_file_media_cloud', array($UM_class, 'get_file_media_cloud'));

    add_action('wp_ajax_post_media_function', array($UM_class, 'post_media_function'));
    add_action('wp_ajax_nopriv_post_media_function', array($UM_class, 'post_media_function'));

    add_action('wp_ajax_delete_media_cloud', array($UM_class, 'delete_media_cloud'));
    add_action('wp_ajax_nopriv_delete_media_cloud', array($UM_class, 'delete_media_cloud'));

    add_action('wp_ajax_recover_cloud', array($UM_class, 'recover_cloud'));
    add_action('wp_ajax_nopriv_recover_cloud', array($UM_class, 'recover_cloud'));

    add_action('wp_ajax_delete_file_cloud', array($UM_class, 'delete_file_cloud'));
    add_action('wp_ajax_nopriv_delete_file_cloud', array($UM_class, 'delete_file_cloud'));
}

class UploadMedia
{

    public function delete_file_cloud()
    {
        if (isset($_POST['action']) && $_POST['action'] === 'delete_file_cloud') {
            $filename = '';
            check_key_ajax_function($filename, null, '', false, true);
        }
    }

    // Make changes to the attachment data here
    // $data is the array containing attachment data
    // $postarr is the array containing the original data sent
    public function modify_attachment_data($data, $postarr)
    {
        //It is currently empty after reloading and may be subject to modifications

        return $data;
    }

    // Make edits to the attachment metadata data here 
    // $metadata is the array containing attachment_metadata data 
    // $attachment_id is the attachment ID
    function modify_attachment_metadata($metadata, $attachment_id)
    {
        $parts = explode('/', $metadata['file']);
        $last_part = array_slice($parts, -3);
        $year = $last_part[0];
        $month = $last_part[1];
        $date = $year . '/' . $month . '/';
        $domain = $_SERVER['HTTP_HOST'];
        $DoDate = $domain . '/' . $date;
        $dell = get_option('md-check-del');
        $cloudLink = get_option('md-cloud-link');
        $upload_info = wp_upload_dir();
        $base_url = $upload_info['baseurl'];
        $base_path = $upload_info['basedir'];
        foreach ($metadata['sizes'] as $size) {
            $file_meta = $size['file'];
            $meta_path = $base_path . "/" . $date . $file_meta;
            $meta_url = $base_url . "/" . $date . $file_meta;
            $meta_name = $DoDate . $file_meta;
            $cloudLink = get_option('md-cloud-link');
            $url_cloud = $cloudLink . '/' . $meta_name;
            $fileInfo = [
                'name' => basename($meta_path),
                'size' => filesize($meta_path),
                'modified' => date("Y-m-d H:i:s", filemtime($meta_path)),
                'url' => $url_cloud
            ];
            check_key_ajax_function($meta_name, $meta_url, $fileInfo);
            ($dell == 1 && file_exists($meta_path)) ? unlink($meta_path) : null;
        };

        $metadata['cloud'] = 'B2';
        return $metadata;
    }

    public function mc_custom_attachment_url($url, $post_id)
    {
        $cloudLink = get_option('md-cloud-link');
        $guid = get_the_guid($post_id);
        if (strpos($guid, $cloudLink) !== false && strpos($url, $cloudLink) === false) {
            $pattern = "/^\S+:\/\/.*\/wp-content\/uploads\//";
            $domain = $_SERVER['HTTP_HOST'];
            $cleanUrl = $cloudLink . '/' . $domain . '/' . preg_replace($pattern, "", $url);
            if (filter_var($cleanUrl)) {
                return $cleanUrl;
            };
        };

        return $url;
    }

    public function mc_custom_image_srcset($sources, $size_array, $image_src, $image_meta, $attachment_id)
    {
        foreach ($sources as $source => &$src) {
            $cloudLink = get_option('md-cloud-link');
            if (strpos($src['url'], $cloudLink) !== false) {
                $pattern = "/^\S+:\/\/.*\/wp-content\/uploads\//";
                $cleanUrl = preg_replace($pattern, "", $src['url']);
                if ($cleanUrl) {
                    $src['url'] = $cleanUrl;
                }
            }
        }

        return $sources;
    }

    public function download_file($url, $savePath)
    {
        if (!file_exists($savePath)) {
            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            $data = curl_exec($ch);
            curl_close($ch);

            $file = fopen($savePath, 'w');
            fwrite($file, $data);
            fclose($file);
        }
    }

    public function upload_files($data = '', $post_file_new = true)
    {
        $upload_info = wp_upload_dir();
        $base_url = $upload_info['baseurl'];
        $base_path = $upload_info['basedir'];
        $path = $post_file_new ? $data['file'] : $data;
        $file_name = basename($path);
        $parts = explode('/', $path);
        $last_part = array_slice($parts, -3);
        $year = $last_part[0];
        $month = $last_part[1];
        $date = $year . '/' . $month . '/';
        $url_upload = $base_url . '/' . $date . $file_name;
        $domain = $_SERVER['HTTP_HOST'];
        $DoDate = $domain . '/' . $date;
        if (!preg_match('/\d{4}\/\d{2}/', $path)) {
            $DoDate = $domain . '/';
            $date = '';
            $url_upload = $base_url . '/' . $file_name;
        }
        $filename = $DoDate . $file_name;

        $dell = get_option('md-check-del');
        $cloudLink = get_option('md-cloud-link');
        $url = $cloudLink . '/' . $filename;
        //push data to the cloud
        $fileInfo = [
            'name' => basename($path),
            'size' => filesize($path),
            'modified' => date("Y-m-d H:i:s", filemtime($path)),
            'url' => $url
        ];
        check_key_ajax_function($filename, $url_upload, $fileInfo);
        if ($post_file_new) {
            $data["url"] = $url;
            return $data;
        } else {
            $pattern = '/^.+\/uploads\//';
            $patternSql = '^.*\/uploads\/';
            global $wpdb;
            $post_id = $wpdb->get_var(
                $wpdb->prepare(
                    "
                    SELECT ID
                    FROM {$wpdb->posts}
                    WHERE post_type = %s AND REGEXP_REPLACE(guid, %s, '') = %s
                    ",
                    'attachment',
                    $patternSql,
                    preg_replace($pattern, '', $path)
                )
            );

            if ($post_id) {
                $wpdb->update(
                    $wpdb->posts,
                    array('guid' => $url),
                    array('ID' => intval($post_id)),
                    array('%s'),
                    array('%d')
                );
                if (strpos($file_type['type'], 'image/') === 0) {
                    $meta_value = get_post_meta($post_id, '_wp_attachment_metadata', true);

                    if ($meta_value) {
                        foreach ($meta_value['sizes'] as $size) {
                            $file_meta = $size['file'];
                            $meta_path = $base_path . "/" . $date . $file_meta;
                            $meta_url = $base_url . "/" . $date . $file_meta;
                            $meta_name = $DoDate . $file_meta;
                            $cloudLink = get_option('md-cloud-link');
                            $url_cloud = $cloudLink . '/' . $meta_name;
                            $fileInfo = [
                                'name' => basename($meta_path),
                                'size' => $size['filesize'],
                                'modified' => '',
                                'url' => $url_cloud
                            ];
                            check_key_ajax_function($meta_name, $meta_url, $fileInfo);
                            ($dell == 1 && file_exists($meta_path)) ? unlink($meta_path) : null;
                        };

                        wp_update_attachment_metadata($post_id, $meta_value);


                        ($dell == 1 && file_exists($path)) ? unlink($path) : null;
                    } else {
                        // Xử lý trường hợp không tìm thấy giá trị meta_value hoặc có lỗi xảy ra
                        wp_send_json_error('The meta_value value was not found or an error occurred.');
                    }
                }
            } else {
                wp_send_json_error('Invalid database');
            }
            return true;
        }
    }


    public function get_new_file_name()
    {
        $upload_dir = wp_get_upload_dir();
        $upload_path = $upload_dir['path'];
        $files = scandir($upload_path);
        $files = array_diff($files, ['.', '..']);

        usort($files, function ($a, $b) use ($upload_path) {
            return filemtime($upload_path . '/' . $b) - filemtime($upload_path . '/' . $a);
        });

        $newest_file = $files[0];
        return $newest_file;
    }



    function getFilesRecursive($folder)
    {
        $files = [];
        $iterator = new \RecursiveIteratorIterator(
            new \RecursiveDirectoryIterator($folder, \RecursiveDirectoryIterator::SKIP_DOTS),
            \RecursiveIteratorIterator::SELF_FIRST,
            \RecursiveIteratorIterator::CATCH_GET_CHILD
        );

        foreach ($iterator as $file) {
            if ($file->isFile()) {
                $files[] = $file->getPathname();
            }
        }

        return $files;
    }

    public function get_file_media_cloud()
    {
        date_default_timezone_set('Asia/Ho_Chi_Minh');
        if (isset($_POST['action']) && $_POST['action'] === 'get_file_media_cloud') {
            $file_upload = [];
            $upload_dir = wp_get_upload_dir();
            $path_folder = $upload_dir['basedir'];
            $base_url = $upload_dir['baseurl'];
            $files = $this->getFilesRecursive($path_folder);

            if ($files !== false) {
                foreach ($files as $file) {
                    $pattern = '/^.+\/uploads\//';
                    $patternSql = '^.*\/uploads\/';

                    global $wpdb;
                    $guid = $wpdb->get_var(
                        $wpdb->prepare(
                            "
                            SELECT guid
                            FROM {$wpdb->posts}
                            WHERE post_type = %s AND REGEXP_REPLACE(guid, %s, '') = %s
                            ",
                            'attachment',
                            $patternSql,
                            preg_replace($pattern, '', $file)
                        )
                    );
                    $cloudLink = get_option('md-cloud-link');
                    if (is_file($file) && $guid) {
                        if (strpos($guid, $cloudLink) === false) {
                            $file_upload[] = $file;
                        };
                    } else if (is_file($file) && strpos($guid, $cloudLink) !== false) {
                        $results = $wpdb->get_var(
                            $wpdb->prepare(
                                "
                                SELECT post_id, meta_value
                                FROM {$wpdb->postmeta}
                                WHERE meta_key = %s AND meta_value = %s
                                ",
                                '_wp_attached_file',
                                preg_replace($pattern, '', $file)
                            )
                        );
                        if ($results) {
                            $post_id = $results->post_id;
                            $meta_value = $results->meta_value;
                            $saveUrl = $base_url . '/' . $meta_value;
                            $wpdb->update(
                                $wpdb->posts,
                                array('guid' => $saveUrl),
                                array('ID' => intval($post_id)),
                                array('%s'),
                                array('%d')
                            );
                            $file_upload[] = $file;
                        }
                    }
                };
            }
            if ($file_upload) {
                wp_send_json_success($file_upload);
            } else {
                wp_send_json_error($file_upload);
            };
        };
    }


    //post media upload
    public function post_media_function()
    {
        date_default_timezone_set('Asia/Ho_Chi_Minh');

        if (isset($_POST['action']) && $_POST['action'] === 'post_media_function') {
            //var_dump($_POST);die;
            $file = $_POST['path'];

            $status = $this->upload_files($file, false);
            if ($status) {

                $all_file = "
<div class='d-flex align-items-center justify-content-between get-image'>
    <p class='my-2'>'$file'</p>
    <i class='fs-2 bi bi-check-lg text-success'></i>
</div>";
            } else {
                $all_file = null;
                // echo "No post found with the given meta value.";
            };
            wp_send_json_success(@$all_file);
        };
    }




    //Recover upload

    public function recover_cloud()
    {
        $startTime = microtime(true);
        $maxExecutionTime = 30;

        if (isset($_POST['action']) && $_POST['action'] === 'recover_cloud') {
            // $link = $_POST['href'];
            global $wpdb;
            $domain = $_SERVER['HTTP_HOST'];
            $cloudLink = get_option('md-cloud-link');
            $url_cloud = $cloudLink . '/' . $domain;
            $posts_id = $wpdb->get_col(
                $wpdb->prepare(
                    "
                    SELECT ID
                    FROM {$wpdb->posts}
                    WHERE post_type = %s AND guid LIKE %s
                    ",
                    'attachment',
                    '%' . $wpdb->esc_like($url_cloud) . '%'
                )
            );
            $upload_info = wp_upload_dir();
            $base_url = $upload_info['baseurl'];
            $base_path = $upload_info['basedir'];

            foreach ($posts_id as $post_id) {
                $currentTime = microtime(true);
                $executionTime = $currentTime - $startTime;
                //Interrupt request
                if ($executionTime >= $maxExecutionTime) {
                    wp_send_json_success('Start_again');
                }
                $guid = get_the_guid($post_id);
                $domain = $_SERVER['HTTP_HOST'];
                $cloudLink = get_option('md-cloud-link');
                $url_cloud = $cloudLink . '/' . $domain;

                $file_location = str_replace($url_cloud, '', $guid);
                $savePath = $base_path . $file_location;
                $saveUrl = $base_url . $file_location;

                $this->download_file($guid, $savePath);
                $file_type = wp_check_filetype($savePath);
                if ($post_id) {
                    $result = $wpdb->update(
                        $wpdb->posts,
                        array('guid' => $saveUrl),
                        array('ID' => intval($post_id)),
                        array('%s'),
                        array('%d')
                    );
                    if (strpos($file_type['type'], 'image/') === 0) {
                        $meta_value = get_post_meta($post_id, '_wp_attachment_metadata', true);
                        $metaBasePath = str_replace(basename($savePath), '', $savePath);
                        $date = substr($metaBasePath, -9);
                        if ($meta_value) {
                            foreach ($meta_value['sizes'] as $size) {
                                $meta_name = $size['file'];
                                $meta_path = $metaBasePath . $meta_name;
                                $cloudLink = get_option('md-cloud-link');
                                $url_b2 = $cloudLink . '/' . $domain . $date . $meta_name;
                                $this->download_file($url_b2, $meta_path);
                            };

                            $meta_value['file'] = $file_location;

                            wp_update_attachment_metadata($post_id, $meta_value);
                        } else {
                            wp_send_json_error('The meta_value value was not found or an error occurred.');
                        }
                    }
                } else {
                    wp_send_json_error('Invalid database');
                }
            }
            wp_send_json_success(true);
        };
    }
    // Delete file

    public function delete_media_cloud()
    {
        if (isset($_POST['action']) && $_POST['action'] === 'delete_media_cloud') {
            global $wpdb;
            $domain = $_SERVER['HTTP_HOST'];
            $cloudLink = get_option('md-cloud-link');
            $url_cloud = $cloudLink . '/' . $domain;
            $posts_id = $wpdb->get_col(
                $wpdb->prepare(
                    "
                    SELECT ID
                    FROM {$wpdb->posts}
                    WHERE post_type = %s AND guid LIKE %s
                    ",
                    'attachment',
                    '%' . $wpdb->esc_like($url_cloud) . '%'
                )
            );
            $upload_info = wp_upload_dir();
            $base_path = $upload_info['basedir'];
            foreach ($posts_id as $post_id) {
                $guid = get_the_guid($post_id);
                $domain = $_SERVER['HTTP_HOST'];
                $cloudLink = get_option('md-cloud-link');
                $url_cloud = $cloudLink . '/' . $domain;

                $file_location = str_replace($url_cloud, '', $guid);
                $delPath = $base_path . $file_location;
                //$delUrl = $base_url . $file_location;
                $file_type = wp_check_filetype($delPath);
                $this->deleteFile($delPath);
                if ($post_id) {
                    if (strpos($file_type['type'], 'image/') === 0) {
                        $meta_value = get_post_meta($post_id, '_wp_attachment_metadata', true);
                        $metaBasePath = str_replace(basename($delPath), '', $delPath);
                        $date = substr($metaBasePath, -9);
                        if ($meta_value) {
                            foreach ($meta_value['sizes'] as $size) {
                                $meta_path = $metaBasePath . $size['file'];
                                $this->deleteFile($meta_path);
                            };
                        } else {
                            wp_send_json_error('The meta_value value was not found or an error occurred.');
                        }
                    }
                } else {
                    wp_send_json_error('Invalid database');
                }
            }
            wp_send_json_success(true);
        };
    }



    public function deleteFile($filePath)
    {
        if (file_exists($filePath)) {
            if (unlink($filePath)) {
                // echo "File deleted successfully.";
            } else {
                // echo "Unable to delete the file.";
            }
        } else {
            // echo "File does not exist.";
        }
    }
}
