<?php

// Đăng ký trường cấu hình
include_once 'config.php';
include_once 'get_size.php';
include_once 'function.php';
require 'vendor/autoload.php';

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\SMTP;

add_action('wp_ajax_table_edu', 'table_edu');
add_action('wp_ajax_nopriv_table_edu', 'table_edu');

function table_edu()
{
    if (isset($_POST['action']) && $_POST['action'] === 'table_edu') {
        global $wpdb;
        $table_name = $wpdb->prefix . 'backup_edu';
        $check = "SELECT * FROM $table_name";
        $setup = connect()->query($check);

        if (!$setup) {

            // Create the table
            $charset_collate = $wpdb->get_charset_collate();
            $sql_backup = "CREATE TABLE IF NOT EXISTS $table_name (
                id INT(11) NOT NULL AUTO_INCREMENT,
                file_path_db VARCHAR(500) NULL,
                file_path_server VARCHAR(500) NULL,
                file_download_db VARCHAR(500) NULL,
                file_download_server VARCHAR(500) NULL,
                file_cloud_db VARCHAR(500) NULL,
                file_cloud_server VARCHAR(500) NULL,
                file_size VARCHAR(500) NULL,
                file_check VARCHAR(500) NULL,
				auto VARCHAR(255) NULL,
				created_at DATETIME NOT NULL,
                PRIMARY KEY (id)
            ) $charset_collate;";
            // Created scheduled
            $sql_file = BACKUP_PATH . 'settings/wp_scheduled_edu.sql';
            $sql_scheduled = file_get_contents($sql_file);
            connect()->multi_query($sql_scheduled);

            require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
            dbDelta($sql_backup);
            // dbDelta($sql_scheduled);
            // Send a response
            wp_send_json_success('Success');
        } else {
            wp_send_json_success('Exist');
        };
    }
}

add_action('wp_ajax_backup_database', 'backup_database');
add_action('wp_ajax_nopriv_backup_database', 'backup_database');

add_action('wp_ajax_backup_server', 'backup_server');
add_action('wp_ajax_nopriv_backup_server', 'backup_server');

function addFilesToZip($dir, $zip, $baseDir)
{
    $files = glob($dir . '/*');
    foreach ($files as $file) {
        if (is_dir($file)) {
            // Exclude the specific folder
            if (!strpos($file, 'backup-file-edu2work')) {
                $relativePath = str_replace($baseDir . '/', '', $file);
                $zip->addEmptyDir($relativePath);
                addFilesToZip($file, $zip, $baseDir);
            }
        } else {
            $relativePath = str_replace($baseDir . '/', '', $file);
            $zip->addFile($file, $relativePath);
        }
    }
}

//Set time
function current_time_edu()
{
    $current_time = date('Y-m-d-his');
    return $current_time;
}
// Get host
function get_host_edu()
{
    $site_url = home_url();
    $parsed_url = parse_url($site_url);
    $host = $parsed_url['host'];
    return $host;
}

// Get domain
function get_domain_edu()
{
    $site_url = home_url();
    $parsed_url = parse_url($site_url);
    $host = $parsed_url['host'];
    $subdomain = explode('.', $host);
    $domain = $subdomain[0];
    return $domain;
}

function backup_database($backup)
{
    $backup = $_POST['action'];
    if (isset($_POST['action']) && $backup === 'backup_database') {
        function createDatabaseZip()
        {
            // Database configuration
            $db_host = 'localhost';
            $db_name = DB_NAME;
            $db_user = DB_USER;
            $db_password = DB_PASSWORD;
            // Add in db
            global $wpdb;
            $table_name = $wpdb->prefix . 'backup_edu';
            $url_content = content_url();
            // $sql = '';
            // Path to store the database backup file
            $backup_dir = BACKUP_DATA;
            $database_filename = 'db-'  . get_domain_edu() . '-' . current_time_edu() . '.sql';
            // Generate the database backup file
            $command = "mysqldump --host={$db_host} --user={$db_user} --password={$db_password} {$db_name} --ignore-table={$db_name}.{$table_name} > {$backup_dir}{$database_filename}";
            $output = [];
            $return_var = 0;

            exec($command, $output, $return_var);

            // Create a zip archive for the database file
            $zip = new ZipArchive();
            $zip_filename = BACKUP_DATA . 'db-' . get_domain_edu() . '-' . current_time_edu() . '.gz';
            $file_name = basename($zip_filename);
            $file_upload = get_host_edu() . '/backup' . '/database/' . basename($zip_filename);
            $url_api = $url_content . '/backup-file-edu2work/' . $file_name;
            // Open the zip file for writing
            if ($zip->open($zip_filename, ZipArchive::CREATE | ZipArchive::OVERWRITE) === true) {
                // Add the database file to the zip
                if ($zip->addFile("{$backup_dir}{$database_filename}", $database_filename)) {
                    $zip->close();
                    // FIXME: Run filesize after zip close;
                    $file_size = filesize($zip_filename);
                    // $file_extension = pathinfo($zip_filename, PATHINFO_EXTENSION);
                    $file_created = date("Y-m-d H:i:s", filemtime($zip_filename));
                    $cloudLink = get_option('md-cloud-link');
                    //$bucket_name = 'servertoidayhoc';
                    //$public_url = 'https://f005.backblazeb2.com/file/' . $bucket_name . '/' . $file_upload;
                    $public_url = $cloudLink . '/' . $file_upload;

                    $sql_backup = "INSERT INTO $table_name (file_path_db, file_download_db, file_cloud_db, file_check, created_at) VALUES ( '$zip_filename', '$url_api', '$public_url', 'local','$file_created')";

                    if (connect()->query($sql_backup)) {
                        unlink("{$backup_dir}{$database_filename}");

                        $file_send = [
                            'name' => $file_name,
                            'path' => $zip_filename,
                            'size' => $file_size,
                            'modified' => $file_created,
                            'url' => $url_api
                        ];
                        wp_send_json_success($file_send);
                    } else {
                        echo "Error: $sql_backup " . mysqli_error(connect());
                    }
                }
            } else {
                echo 'Failed to create database zip file.';
            }
        }
        createDatabaseZip();
    } else {
        echo 'No action';
    };
}


function backup_server($backup)
{
    $backup = $_POST['action'];
    if (isset($_POST['action']) && $backup === 'backup_server') {
        function createWPZip()
        {
            $url_content = content_url();
            // wp_send_json_success($url_content);

            global $wpdb;
            $table_name = $wpdb->prefix . 'backup_edu';

            // TODO: Uncomment to zip all file wp
            $WP_dir = ABSPATH;

            $zip = new ZipArchive();
            $zip_filename = BACKUP_DATA . 'wp-' . get_domain_edu() . '-' . current_time_edu() . '.zip';

            $file_database = $_POST['path'];
            $file_size_db = $_POST['fileSize'];

            $file_name = basename($zip_filename);
            $file_upload = get_host_edu() . '/backup' . '/server/' . basename($zip_filename);

            $url_api = $url_content . '/backup-file-edu2work/' . $file_name;
            // Open the zip file for writing
            if ($zip->open($zip_filename, ZipArchive::CREATE | ZipArchive::OVERWRITE) === true) {
                addFilesToZip($WP_dir, $zip, $WP_dir);
                // Close the zip archive
                $zip->close();

                $file_size = filesize($zip_filename);
                $file_created = date("Y-m-d H:i:s", filemtime($zip_filename));
                $cloudLink = get_option('md-cloud-link');
                //$bucket_name = 'servertoidayhoc';
                //$public_url = 'https://f005.backblazeb2.com/file/' . $bucket_name . '/' . $file_upload;
                $public_url = $cloudLink . '/' . $file_upload;

                $sql_backup = "UPDATE $table_name SET file_path_server = '$zip_filename', file_download_server = '$url_api', file_cloud_server = '$public_url', file_size = '$file_size_db,$file_size' WHERE file_path_db = '$file_database'";

                if (connect()->query($sql_backup)) {
                    wp_send_json_success($file_name);
                } else {
                    echo "Error: $sql_backup " . mysqli_error(connect());
                }
            } else {
                echo 'Failed to create themes zip file.';
            }
        }
        createWPZip();
    } else {
        echo 'No action';
    };
};


function moveDirectory($src, $dst)
{
    $dir = opendir($src);
    @mkdir($dst);

    while (($file = readdir($dir)) !== false) {
        if ($file !== '.' && $file !== '..') {
            $srcFile = $src . '/' . $file;
            $dstFile = $dst . '/' . $file;

            if (is_dir($srcFile)) {
                moveDirectory($srcFile, $dstFile);
            } else {
                if (rename($srcFile, $dstFile)) {
                    // File moved successfully
                } else {
                    echo "Failed to move file: $file<br>";
                }
            }
        }
    }

    closedir($dir);
    rmdir($src);
}
function removeDirectory($directory)
{
    if (!is_dir($directory)) {
        return;
    }

    $files = array_diff(scandir($directory), array('.', '..'));

    foreach ($files as $file) {
        $path = $directory . '/' . $file;

        if (is_dir($path)) {
            removeDirectory($path);
        } else {
            unlink($path);
        }
    }
    rmdir($directory);
}
add_action('wp_ajax_restore_server', 'restore_server');
add_action('wp_ajax_nopriv_restore_server', 'restore_server');
function restore_server()
{
    if (isset($_POST['action']) && $_POST['action'] === 'restore_server') {

        $zip_file = $_POST['backupFile'];
        $file_name = pathinfo($zip_file, PATHINFO_FILENAME);

        $extract_dir = BACKUP_DATA . $file_name;
        // Create a new instance of the ZipArchive class
        $zip = new ZipArchive();
        $files_in_zip = [];
        // Open the zip file
        if ($zip->open($zip_file) === true) {
            // Extract the contents of the zip file to the extraction directory
            if ($zip->extractTo($extract_dir)) {
                // Close the zip file
                $zip->close();

                $themes_dir = WP_CONTENT_DIR . '/themes';
                $files_themes = glob($themes_dir . '/*');
                foreach ($files_themes as $file_themes) {
                    $destination_themes = BACKUP_THEMES . basename($file_themes);
                    rename($file_themes, $destination_themes);
                };

                $uploads = wp_get_upload_dir();
                $uploads_dir = $uploads['basedir'];
                $files_uploads = glob($uploads_dir . '/*');
                foreach ($files_uploads as $file_uploads) {
                    $destination_uploads = BACKUP_UPLOADS . basename($file_uploads);
                    rename($file_uploads, $destination_uploads);
                };

                $plugins_dir = WP_PLUGIN_DIR;
                $files_plugins = glob($plugins_dir . '/*');
                foreach ($files_plugins as $file_plugins) {
                    $destination_plugins = BACKUP_PLUGINS . basename($file_plugins);
                    rename($file_plugins, $destination_plugins);
                };


                $extracted_items_file = array_filter(glob($extract_dir . '/*'), 'is_dir');
                $extracted_items_dir = glob($extract_dir . '/*');
                $extracted_items = array_merge($extracted_items_file, $extracted_items_dir);



                // Move each item to the parent folder
                foreach ($extracted_items as $item) {
                    $item_name = basename($item);
                    $new_location = ABSPATH . $item_name;
                    // Add the extracted file to the array
                    $files_in_zip[] = $item_name;
                    if ($item_name === 'wp-config.php') {
                        // Skip renaming the file 'wp-config.php'
                        continue;
                    }
                    if (is_file($item)) { // Move file
                        if (rename($item, $new_location)) {
                        } else {
                            echo "Failed to move file: $item_name<br>";
                        }
                    } elseif (is_dir($item)) { // Move folder
                        if (moveDirectory($item, $new_location)) {
                        } else {
                            // var_dump(rename($item, $new_location));
                            // echo "Failed to move folder: $item_name<br>";
                        }
                    }
                }
                $msg = 'success restore';
                removeDirectory(OLD_PLUGINS);
                removeDirectory(OLD_THEMES);
                removeDirectory(OLD_UPLOADS);
                removeDirectory($extract_dir);
                wp_send_json_success($msg);
            }
        }
    }
}


add_action('wp_ajax_restore_database', 'restore_database');
add_action('wp_ajax_nopriv_restore_database', 'restore_database');
function restore_database()
{
    if (isset($_POST['action']) && $_POST['action'] === 'restore_database') {

        $zip_file = $_POST['backupFile'];
        $zip = new ZipArchive();
        // Open the zip file
        if ($zip->open($zip_file) === true) {
            // Extract the contents of the zip file to the extraction directory
            if ($zip->extractTo(BACKUP_DATA)) {
                $parent_folder = $zip->getNameIndex(0);
                $sql_file = BACKUP_DATA . $parent_folder;
                $size = filesize($sql_file);

                if ($size !== 0) {
                    $sql_content = file_get_contents($sql_file);
                    if (connect()->multi_query($sql_content)) {
                        unlink(BACKUP_DATA . $parent_folder);
                        wp_send_json_success('Success');
                    } else {
                        echo "Error executing SQL statements: " . connect()->error;
                    };
                } else {
                    wp_send_json_error("Failed to restore database \nPlease check your back up!");
                    unlink(BACKUP_DATA . $parent_folder);
                }
            };
        } else {
            echo 'failed to unzip';
        };
    };
}



add_action('wp_ajax_delete_backup', 'delete_backup');
add_action('wp_ajax_nopriv_delete_backup', 'delete_backup');
function delete_backup()
{
    if (isset($_POST['action']) && $_POST['action'] === 'delete_backup') {
        global $wpdb;
        $table_name = $wpdb->prefix . 'backup_edu';
        $id = $_POST['deleteFile'];
        $sql = "SELECT * FROM $table_name WHERE id = '$id'";
        $result = connect()->query($sql);
        $row = mysqli_fetch_array($result);
        $path_server = $row['file_path_server'];
        $path_db = $row['file_path_db'];

        // var_dump($path);
        $delete = "DELETE FROM $table_name WHERE id = '$id' AND file_check = 'local'";
        if (connect()->query($delete)) {
            unlink($path_db);
            unlink($path_server);
            wp_send_json_success($path_db);
        }
    }
}

add_action('wp_ajax_cloud_backup', 'cloud_backup');
add_action('wp_ajax_nopriv_cloud_backup', 'cloud_backup');
function cloud_backup()
{
    if (isset($_POST['action']) && $_POST['action'] === 'cloud_backup') {

        $cloudLink = get_option('md-cloud-link');
        //$bucket_name = 'servertoidayhoc';
        global $wpdb;
        $table_name = $wpdb->prefix . 'backup_edu';
        $file_name = explode(',', $_POST['path']);
        $url_api = explode(',', $_POST['api']);
        $file_size = explode(',', $_POST['size']);
        $path_cloud = ['database', 'server'];
        $file_created = $_POST['created'];

        $all_file = basename($file_name[0]) . '|' . basename($file_name[1]);
        $all_size = intval($file_size[0] + $file_size[1]);
        $file_cloud_db = $cloudLink . '/' . get_host_edu() . '/backup' . "/$path_cloud[0]/" . basename($file_name[0]);
        $file_cloud_server = $cloudLink . '/' . get_host_edu() . '/backup' . "/$path_cloud[1]/" . basename($file_name[1]);
        $url_cloud = $file_cloud_db . '|' . $file_cloud_server;
        $remain = remain_cloud();
        if ($all_size < $remain) {
            for ($i = 0; $i < count($file_name); $i++) {
                $file_upload = get_host_edu() . '/backup' . "/$path_cloud[$i]/" . basename($file_name[$i]);
                $url = $url_api[$i];
                //$public_url = 'https://f005.backblazeb2.com/file/' . $bucket_name . '/' . $file_upload;
                $public_url = $cloudLink . '/' . $file_upload;

                $file_info = [
                    'name' => $all_file,
                    'size' => $file_size[$i],
                    'size_return' => $all_size,
                    'modified' => $file_created,
                    'url' => $public_url,
                    'url_cloud' => $url_cloud
                ];
                $check = check_key_ajax_function($file_upload, $url, $file_info);
                if ($check == 'Complete push up.' || $check == NULL) {
                    $sql_cloud = "UPDATE $table_name SET file_check = 'cloud' WHERE created_at = '$file_created'";
                    if (connect()->query($sql_cloud)) {
                    } else {
                        echo "Error: $sql_cloud " . mysqli_error(connect());
                    }
                } else {
                    wp_send_json_error('Upload cloud failed');
                };
            };
        } else {
            wp_send_json_error('Storage full');
        }
        if ($check == 'Complete push up.' || $check == NULL) {
            unlink($file_name[0]);
            unlink($file_name[1]);
            wp_send_json_success($file_name);
        };
    };
};


add_action('wp_ajax_database_cloud', 'database_cloud');
add_action('wp_ajax_nopriv_database_cloud', 'database_cloud');

function database_cloud()
{
    if (isset($_POST['action']) && $_POST['action'] === 'database_cloud') {
        $file_name = basename($_POST['downloadFile']);
        $get_file = file_get_contents($_POST['downloadFile']);
        if (file_put_contents(BACKUP_DATA . $file_name, $get_file)) {
            $zip_file = $_POST['backupFile'];
            $zip = new ZipArchive();
            // Open the zip file
            if ($zip->open($zip_file) === true) {
                // Extract the contents of the zip file to the extraction directory
                if ($zip->extractTo(BACKUP_DATA)) {
                    $parent_folder = $zip->getNameIndex(0);
                    $sql_file = BACKUP_DATA . $parent_folder;
                    $size = filesize($sql_file);
                    if ($size !== 0) {
                        $sql_content = file_get_contents($sql_file);
                        if (connect()->multi_query($sql_content)) {
                            unlink(BACKUP_DATA . $parent_folder);
                            unlink(BACKUP_DATA . $file_name);
                            wp_send_json_success($parent_folder);
                        } else {
                            echo "Error executing SQL statements: " . connect()->error;
                        };
                    } else {
                        wp_send_json_error("Failed to restore database \nPlease check your back up!");
                        unlink(BACKUP_DATA . $parent_folder);
                    }
                };
            } else {
                echo 'failed to unzip';
            };
        };
    }
}

add_action('wp_ajax_change_url', 'change_url');
add_action('wp_ajax_nopriv_change_url', 'change_url');
function change_url()
{
    if (isset($_POST['action']) && $_POST['action'] === 'change_url') {
        global $wpdb;
        @$table_name = $wpdb->prefix . 'options';
        $host = $_POST['href'];
        $site = "UPDATE $table_name SET option_value = '$host' WHERE option_name = 'siteurl'";
        $home = "UPDATE $table_name SET option_value = '$host' WHERE option_name = 'home'";

        if (@$wpdb->query($site) !== false && @$wpdb->query($home) !== false) {
            wp_send_json_success('done');
        } else {
            echo "Error: " . $wpdb->last_error;
        };
    }
}

add_action('wp_ajax_server_cloud', 'server_cloud');
add_action('wp_ajax_nopriv_server_cloud', 'server_cloud');

function server_cloud()
{
    if (isset($_POST['action']) && $_POST['action'] === 'server_cloud') {
        $file_name = basename($_POST['downloadFile']);
        @$get_file = file_get_contents($_POST['downloadFile']);
        if (file_put_contents(BACKUP_DATA . $file_name, $get_file)) {

            $zip_file = $_POST['backupFile'];
            $file_name_extract = pathinfo($zip_file, PATHINFO_FILENAME);

            $extract_dir = BACKUP_DATA . $file_name_extract;

            // Create a new instance of the ZipArchive class
            $zip = new ZipArchive();
            $files_in_zip = [];

            // Open the zip file
            if ($zip->open($zip_file) === true) {
                // Extract the contents of the zip file to the extraction directory
                if ($zip->extractTo($extract_dir)) {

                    $zip->close();

                    $themes_dir = WP_CONTENT_DIR . '/themes';
                    $files_themes = glob($themes_dir . '/*');
                    foreach ($files_themes as $file_themes) {
                        $destination_themes = BACKUP_THEMES . basename($file_themes);
                        rename($file_themes, $destination_themes);
                    };

                    $uploads = wp_get_upload_dir();
                    $uploads_dir = $uploads['basedir'];
                    $files_uploads = glob($uploads_dir . '/*');
                    foreach ($files_uploads as $file_uploads) {
                        $destination_uploads = BACKUP_UPLOADS . basename($file_uploads);
                        rename($file_uploads, $destination_uploads);
                    };

                    $plugins_dir = WP_PLUGIN_DIR;
                    $files_plugins = glob($plugins_dir . '/*');
                    foreach ($files_plugins as $file_plugins) {
                        $destination_plugins = BACKUP_PLUGINS . basename($file_plugins);
                        rename($file_plugins, $destination_plugins);
                    };

                    $extracted_items_file = array_filter(glob($extract_dir . '/*'), 'is_dir');
                    $extracted_items_dir = glob($extract_dir . '/*');
                    $extracted_items = array_merge($extracted_items_file, $extracted_items_dir);

                    // Move each item to the parent folder
                    foreach ($extracted_items as $item) {
                        $item_name = basename($item);
                        $new_location = ABSPATH . $item_name;

                        // Add the extracted file to the array
                        $files_in_zip[] = $item_name;
                        if ($item_name === 'wp-config.php') {
                            // Skip renaming the file 'wp-config.php'
                            continue;
                        }
                        if (is_file($item)) { // Move file
                            if (rename($item, $new_location)) {
                            } else {
                                echo "Failed to move file: $item_name<br>";
                            }
                        } elseif (is_dir($item)) { // Move folder
                            if (moveDirectory($item, $new_location)) {
                            } else {
                                // var_dump(rename($item, $new_location));
                                // echo "Failed to move folder: $item_name<br>";
                            }
                        }
                    }
                    $msg = 'success restore';
                    removeDirectory(OLD_PLUGINS);
                    removeDirectory(OLD_THEMES);
                    removeDirectory(OLD_UPLOADS);
                    removeDirectory($extract_dir);
                    unlink($_POST['backupFile']);
                    wp_send_json_success($msg);
                }
            };
        } else {
            wp_send_json_error('Failed');
        };
    }
}

add_action('wp_ajax_get_backup_file', 'get_backup_file');
add_action('wp_ajax_nopriv_get_backup_file', 'get_backup_file');

function get_backup_file()
{
    if (isset($_POST['action']) && $_POST['action'] === 'get_backup_file') {
        $dir = BACKUP_DATA;
        $cloud = get_option('md-cloud-link') . '/';
        $row = check_key_ajax_function();
        $result = [
            'row' => $row,
            'dir' => $dir,
            'cloud' => $cloud,
        ];
        wp_send_json_success($result);
    }
}

add_action('wp_ajax_restore_upload', 'restore_upload');
add_action('wp_ajax_nopriv_restore_upload', 'restore_upload');

function restore_upload()
{
    if (isset($_POST['action']) && $_POST['action'] === 'restore_upload') {
        foreach ($_FILES as $file) {
            $tmp = $file['tmp_name'];
            $file_name = pathinfo($file['name'], PATHINFO_FILENAME);
            $extension = pathinfo($file['name'], PATHINFO_EXTENSION);
            $destination_file = BACKUP_DATA . $file['name'];
            $extract_dir = BACKUP_DATA . $file_name;
            if (move_uploaded_file($tmp, $destination_file)) {
                // File moved successfully
                if ($extension == 'sql') {
                    $file_sql = file_get_contents($destination_file);
                    // var_dump($file_sql);
                    if (connect()->multi_query($file_sql)) {
                        unlink($destination_file);
                    } else {
                        $zip = new ZipArchive();
                        if ($zip->open($destination_file) === true) {
                            if ($zip->extractTo($extract_dir)) {

                                $zip->close();

                                $themes_dir = WP_CONTENT_DIR . '/themes';
                                $files_themes = glob($themes_dir . '/*');
                                foreach ($files_themes as $file_themes) {
                                    $destination_themes = BACKUP_THEMES . basename($file_themes);
                                    rename($file_themes, $destination_themes);
                                };

                                $uploads = wp_get_upload_dir();
                                $uploads_dir = $uploads['basedir'];
                                $files_uploads = glob($uploads_dir . '/*');
                                foreach ($files_uploads as $file_uploads) {
                                    $destination_uploads = BACKUP_UPLOADS . basename($file_uploads);
                                    rename($file_uploads, $destination_uploads);
                                };

                                $plugins_dir = WP_PLUGIN_DIR;
                                $files_plugins = glob($plugins_dir . '/*');
                                foreach ($files_plugins as $file_plugins) {
                                    $destination_plugins = BACKUP_PLUGINS . basename($file_plugins);
                                    rename($file_plugins, $destination_plugins);
                                };

                                $extracted_items_file = array_filter(glob($extract_dir . '/*'), 'is_dir');
                                $extracted_items_dir = glob($extract_dir . '/*');
                                $extracted_items = array_merge($extracted_items_file, $extracted_items_dir);

                                // Move each item to the parent folder
                                foreach ($extracted_items as $item) {
                                    $item_name = basename($item);
                                    $new_location = ABSPATH . $item_name;
                                    // Add the extracted file to the array
                                    $files_in_zip[] = $item_name;
                                    if ($item_name === 'wp-config.php') {
                                        // Skip renaming the file 'wp-config.php'
                                        continue;
                                    }
                                    if (is_file($item)) { // Move file
                                        if (rename($item, $new_location)) {
                                        } else {
                                            echo "Failed to move file: $item_name<br>";
                                        }
                                    } elseif (is_dir($item)) { // Move folder
                                        if (moveDirectory($item, $new_location)) {
                                        } else {
                                            // var_dump(rename($item, $new_location));
                                            // echo "Failed to move folder: $item_name<br>";
                                        }
                                    }
                                }
                                $msg = 'success restore';
                                removeDirectory(OLD_PLUGINS);
                                removeDirectory(OLD_THEMES);
                                removeDirectory(OLD_UPLOADS);
                                removeDirectory($extract_dir);
                                unlink($destination_file);
                                wp_send_json_success($msg);
                            }
                        }
                    }
                } else {
                }
            } else {
                // Error moving the file
                echo "Error moving the file";
            }
        };
        $dir = BACKUP_DATA . $_FILES['fileDatabase']['name'];
    };
}
add_action('wp_ajax_scheduled', 'scheduled');
add_action('wp_ajax_nopriv_scheduled', 'scheduled');

function scheduled()
{
    if (isset($_POST['action']) && $_POST['action'] === 'scheduled') {
        // $check = "SELECT * FROM 'wp_scheduled_edu'";
        $scheduled = $_POST['scheduled'];
        $update = "UPDATE wp_scheduled_edu SET save_change = 'save' WHERE scheduled = '$scheduled' ";
        $update_hide = "UPDATE wp_scheduled_edu SET save_change = 'none' WHERE scheduled != '$scheduled'";
        if (connect()->query($update) && connect()->query($update_hide)) {
            wp_send_json_success($scheduled);
        } else {
            echo "Error: $update " . mysqli_error(connect());
        };
    }
}

function mailbox($mailbox = null, $mail_pass = '', $mail_reply = null, $website = null, $mail_sub = null, $send_reply = true)
{
    $mail = new PHPMailer;
    $mail->isSMTP();
    $mail->Host = 'smtp.gmail.com';
    $mail->SMTPAuth = true;
    $mail->Username = $mailbox;
    $mail->Password = $mail_pass;
    $mail->SMTPSecure = 'ssl';
    $mail->Port = 465;
    // $mail->SMTPDebug = SMTP::DEBUG_CONNECTION;

    $mail->setFrom($mailbox, 'Backup Cloud by Edu2Work');
    $mail->addAddress($mail_reply);
    $mail->Subject = 'SMTP Mail: Request for clone website: ' . get_host_edu();
    // Set the HTML body
    $mail->isHTML(true);
    // $mail->Body = $send_reply
    //     ? '<center><h2 style="margin:.5em;">User domain: ' . get_host_edu() . '</h2><h2 style="margin:.5em;">Host require change to: ' . $website . '</h2><h2 style="margin:.5em;">User mail: ' . $mail_sub . '</h2></center>'
    //     : include 'mail_format.php';
    if ($send_reply) {
        $body = '<center><h2 style="margin:.5em;">User domain: ' . get_host_edu() . '</h2><h2 style="margin:.5em;">Host require change to: ' . $website . '</h2><h2 style="margin:.5em;">User mail: ' . $mail_sub . '</h2></center>';
    } else {
        ob_start();
        include 'mail_format.php';
        $body = ob_get_clean();
    }
    $mail->Body = $body;
    // Optional: Set reply-to address
    // Send the email
    if ($mail->send()) {
        wp_send_json_success('success');
    } else {
        wp_send_json_error('Failed to send email. Error: ' . $mail->ErrorInfo);
    }
}

add_action('wp_ajax_send_mail', 'send_mail');
add_action('wp_ajax_nopriv_send_mail', 'send_mail');
function send_mail()
{
    if (isset($_POST['action']) && $_POST['action'] === 'send_mail') {
        $mail_box = 'anhtranocd@gmail.com';
        $mail_pass = 'cdhndipgzwcprwng';
        $mail_reply = 'tuananh248997@gmail.com';
        $website = $_POST['website'];
        $mail_sub = $_POST['email'];
        mailbox($mail_box, $mail_pass, $mail_reply, $website, $mail_sub, true);
    }
}

add_action('wp_ajax_send_reply', 'send_reply');
add_action('wp_ajax_nopriv_send_reply', 'send_reply');
function send_reply()
{
    if (isset($_POST['action']) && $_POST['action'] === 'send_reply') {
        $mail_box = 'anhtranocd@gmail.com';
        $mail_pass = 'cdhndipgzwcprwng';
        $mail_reply = $_POST['email'];
        $website = $_POST['website'];
        $mail_sub = $_POST['email'];
        mailbox($mail_box, $mail_pass, $mail_reply, $website, $mail_sub, false);
    }
}
// get server size
require_once 'server_size.php';
add_action('wp_ajax_get_dir_size', 'get_dir_size');
add_action('wp_ajax_nopriv_get_dir_size', 'get_dir_size');
function get_dir_size()
{
    if (isset($_POST['action']) && $_POST['action'] === 'get_dir_size') {
        global $wpdb;
        $table_name = $wpdb->prefix . 'backup_edu';
        $check = "SELECT * FROM $table_name WHERE file_check ='local'";
        $result = connect()->query($check);
        if ($result->num_rows > 0) {
            $get_size = size_convert_edu(get_directory_size(ABSPATH));
            wp_send_json_success($get_size);
        } else {
            $get_size = size_convert_edu(get_directory_size(ABSPATH));
            wp_send_json_error($get_size);
        }
    }
}

add_action('wp_ajax_get_plugins_size', 'get_plugins_size');
add_action('wp_ajax_nopriv_get_plugins_size', 'get_plugins_size');
function get_plugins_size()
{
    if (isset($_POST['action']) && $_POST['action'] === 'get_plugins_size') {
        $plugin_dir = WP_PLUGIN_DIR;
        $get_size = size_convert_edu(get_directory_size($plugin_dir));
        wp_send_json_success($get_size);
    }
}
add_action('wp_ajax_get_themes_size', 'get_themes_size');
add_action('wp_ajax_nopriv_get_themes_size', 'get_themes_size');
function get_themes_size()
{
    if (isset($_POST['action']) && $_POST['action'] === 'get_themes_size') {
        $themes_dir = WP_CONTENT_DIR . '/themes';
        $get_size = size_convert_edu(get_directory_size($themes_dir));
        wp_send_json_success($get_size);
    }
}
add_action('wp_ajax_get_uploads_size', 'get_uploads_size');
add_action('wp_ajax_nopriv_get_uploads_size', 'get_uploads_size');
function get_uploads_size()
{
    if (isset($_POST['action']) && $_POST['action'] === 'get_uploads_size') {
        $upload = wp_get_upload_dir();
        $upload_dir = $upload['basedir'];
        $get_size = size_convert_edu(get_directory_size($upload_dir));
        wp_send_json_success($get_size);
    }
}

add_action('wp_ajax_get_data_size', 'get_data_size');
add_action('wp_ajax_nopriv_get_data_size', 'get_data_size');
function get_data_size()
{
    if (isset($_POST['action']) && $_POST['action'] === 'get_data_size') {
        global $wpdb;
        $table_prefix = $wpdb->prefix;

        // SQL query to fetch the database size
        $query = "SELECT SUM(data_length + index_length) AS size FROM information_schema.TABLES WHERE TABLE_SCHEMA = '{$wpdb->dbname}' AND TABLE_NAME LIKE '{$table_prefix}%';";

        // Execute the query
        $result = $wpdb->get_row($query);

        // Access the size value
        $databaseSize = $result->size;
        $get_size = size_convert_edu($databaseSize);
        wp_send_json_success($get_size);
    }
}
/** */
//TODO: Delete this
// add_action('wp_ajax_delete_cloud', 'delete_cloud');
// add_action('wp_ajax_nopriv_delete_cloud', 'delete_cloud');
// function delete_cloud()
// {
//     if (isset($_POST['action']) && $_POST['action'] === 'delete_cloud') {
//         global $wpdb;
//         $table_name = $wpdb->prefix . 'backup_edu';
//         $id = $_POST['id'];
//         $sql = "SELECT * FROM $table_name WHERE id = '$id'";
//         $result = connect()->query($sql);
//         $row = mysqli_fetch_array($result);
//         $path_cloud = ['database', 'server'];
//         $path_delete = [$row['file_path_db'], $row['file_path_server']];
//         for ($i = 0; $i < count($path_delete); $i++) {
//             $file_delete = get_host_edu() . "/backup" . "/$path_cloud[$i]/" . basename($path_delete[$i]);
//             $delete_file = check_key_ajax_function($file_delete, null, '', 'delete_file_cloud');
//             var_dump($delete_file);
//         }
//         // wp_send_json_success($delete_file);
//     }
// }
add_action('wp_ajax_hard_reset', 'hard_reset');
add_action('wp_ajax_nopriv_hard_reset', 'hard_reset');
function hard_reset()
{
    if (isset($_POST['action']) && $_POST['action'] === 'hard_reset') {
        $cloudLink = get_option('md-cloud-link');
        $file_reset = $cloudLink . '/' . 'hard-reset/wp-content.zip';
        $file_name = basename($file_reset);
        $get_file = file_get_contents($file_reset);
        if (file_put_contents(BACKUP_DATA . $file_name, $get_file)) {
            $zip_file = BACKUP_DATA . $file_name;
            $file_name_extract = pathinfo($zip_file, PATHINFO_FILENAME);
            $extract_dir = BACKUP_DATA . $file_name_extract;
            $zip = new ZipArchive();
            // Open the zip file
            if ($zip->open($zip_file) === true) {
                // Extract the contents of the zip file to the extraction directory
                if ($zip->extractTo($extract_dir)) {
                    unlink($zip_file);

                    $zip->close();
                    $themes_dir = WP_CONTENT_DIR . '/themes';
                    $files_themes = glob($themes_dir . '/*');
                    foreach ($files_themes as $file_themes) {
                        $destination_themes = BACKUP_THEMES . basename($file_themes);
                        rename($file_themes, $destination_themes);
                    };

                    $uploads = wp_get_upload_dir();
                    $uploads_dir = $uploads['basedir'];
                    $files_uploads = glob($uploads_dir . '/*');
                    foreach ($files_uploads as $file_uploads) {
                        $destination_uploads = BACKUP_UPLOADS . basename($file_uploads);
                        rename($file_uploads, $destination_uploads);
                    };

                    $plugins_dir = WP_PLUGIN_DIR;
                    $files_plugins = glob($plugins_dir . '/*');
                    foreach ($files_plugins as $file_plugins) {
                        $destination_plugins = BACKUP_PLUGINS . basename($file_plugins);
                        rename($file_plugins, $destination_plugins);
                    };

                    $extracted_items_file = array_filter(glob($extract_dir . '/*'), 'is_dir');
                    $extracted_items_dir = glob($extract_dir . '/*');
                    $extracted_items = array_merge($extracted_items_file, $extracted_items_dir);

                    // Move each item to the parent folder
                    foreach ($extracted_items as $item) {
                        $item_name = basename($item);
                        $new_location = ABSPATH . $item_name;

                        // Add the extracted file to the array
                        $files_in_zip[] = $item_name;
                        if ($item_name === 'wp-config.php') {
                            // Skip renaming the file 'wp-config.php'
                            continue;
                        }
                        if (is_file($item)) { // Move file
                            if (rename($item, $new_location)) {
                            } else {
                                echo "Failed to move file: $item_name<br>";
                            }
                        } elseif (is_dir($item)) { // Move folder
                            if (moveDirectory($item, $new_location)) {
                            } else {
                                // var_dump(rename($item, $new_location));
                                // echo "Failed to move folder: $item_name<br>";
                            }
                        }
                    }
                    $msg = 'success restore';
                    removeDirectory(OLD_PLUGINS);
                    removeDirectory(OLD_THEMES);
                    removeDirectory(OLD_UPLOADS);
                    removeDirectory($extract_dir);
                    wp_send_json_success($msg);
                }
            };
        }
    }
}

$GLOBALS['api_urls'] = array(API_URL1, API_URL2, API_URL3);

add_action('wp_ajax_check_key_ajax_function', 'check_key_ajax_function');
add_action('wp_ajax_nopriv_check_key_ajax_function', 'check_key_ajax_function');
function check_key_ajax_function($filename = null, $url = null, $info = '', $action = null)
{
    if (isset($_POST)) {
        // foreach ($GLOBALS['api_urls'] as $api_url) {
        $key = isset($_POST["key"]) ? esc_attr($_POST["key"]) : (esc_attr(get_option('md_edu_key')) ?? '');
        if ($key == '') {
            wp_send_json_error("Naughty boy, you should stop, don't destroy it.");
        }
        $return = false;
        if (!$action) {
            $return = true;
            $action = isset($_POST["action"]) ? $_POST["action"] : "upload-attachment";
        }
        $info = json_encode($info);
        $request_args = array(
            'method' => 'POST',
            'timeout' => '45',
            'headers' => array(
                'Content-Type' => 'application/json'
            ),
            'body' => json_encode(array(
                'key' => $key,
                'action' => $action,
                'domain' => $_SERVER['HTTP_HOST'],
                'filename' => $filename,
                'url' => $url,
                'info' => $info
            )),
        );
        $response = wp_remote_request(API_URL1, $request_args);
        if (is_wp_error($response)) {
            //$error_message = $response->get_error_message();
        } else {
            $response_body = wp_remote_retrieve_body($response);
            $data = json_decode($response_body, true);
            if (isset($data['notification']) && $data['notification'] == 'Successful authentication') {
                update_option('md_edu_key', $key);
                update_option('md-cloud-link', $data['cloud_link']);
                update_option('md-check-del', 0);
                update_option('md-status', 1);
                wp_send_json_success($data['notification']);
            }
            (($return && $action !== 'get_backup_file' && ($data != 'Complete push up.') && ($data != 'Path already exists.') && ($data != NULL)))  ? wp_send_json_success($data) && die() : '';

            return $data;
        }
        // }
        //
    }
}


add_action('wp_ajax_verify_cloud', 'verify_cloud');
add_action('wp_ajax_nopriv_verify_cloud', 'verify_cloud');
function verify_cloud()
{
    if (isset($_POST['action']) && $_POST['action'] === 'verify_cloud') {
        foreach ($GLOBALS['api_urls'] as $api_url) {
            $request_args = array(
                'method' => 'POST',
                'timeout' => '45',
                'headers' => array(
                    'Content-Type' => 'application/json'
                ),
                'body' => json_encode(array(
                    'token' => $_POST['token'],
                    'action' => 'verify_cloud',
                    'domain' => $_SERVER['HTTP_HOST']
                )),
            );
            $response = wp_remote_request($api_url, $request_args);

            if (is_wp_error($response)) {
                //$error_message = $response->get_error_message();
                //wp_send_json_error("Error: " . $error_message);
                continue; // Switch to the next API if an error occurs
            } else {
                $response_body = wp_remote_retrieve_body($response);
                $data = json_decode($response_body, true);
                //var_dump($data);die;
                if (isset($data['notification']) && $data['notification'] == 'Verified successfully!') {
                    update_option('md_edu_key', $data['key']);
                    update_option('md-cloud-link', $data['cloud_link']);
                    $api_key = $data['key'];
                    update_option('md-check-del', 0);
                    update_option('md-status', 1);
                    wp_send_json_success('Verified successfully!' . "\n" . "Your api key: $api_key");
                } else {
                    wp_send_json_success($data);
                }
            }

            return; //
        }
        wp_send_json_error("Error: All API requests failed!");
    }
}

function send_mail_cloud($action)
{
    foreach ($GLOBALS['api_urls'] as $api_url) {
        $request_args = array(
            'method' => 'POST',
            'timeout' => '45',
            'headers' => array(
                'Content-Type' => 'application/json'
            ),
            'body' => json_encode(array(
                'action' => $action,
                'domain' => $_SERVER['HTTP_HOST'],
                'data' => $_POST
            )),
        );
        $response = wp_remote_request($api_url, $request_args);
        if (is_wp_error($response)) {
            //$error_message = $response->get_error_message();
            //wp_send_json_error("Error: " . $error_message);
            continue; // Switch to the next API if an error occurs
        } else {
            $response_body = wp_remote_retrieve_body($response);
            $data = json_decode($response_body, true);
            return $data; //
        }
    }
    wp_send_json_error("Error: All API requests failed!");
}

//These two functions are the same, but absolutely do not combine them, it is very difficult to fix
add_action('wp_ajax_sign_up_cloud', 'sign_up_cloud');
add_action('wp_ajax_nopriv_sign_up_cloud', 'sign_up_cloud');
function sign_up_cloud()
{
    if (isset($_POST['action']) && $_POST['action'] === 'sign_up_cloud') {
        $data = send_mail_cloud($_POST['action']);
        if ($data == 'Email sent successfully, check your inbox!') {
            wp_send_json_success($data);
        } else {
            wp_send_json_error("Error: " . $data);
        }
    }
}
//These two functions are the same, but absolutely do not combine them, it is very difficult to fix
add_action('wp_ajax_forgot_cloud', 'forgot_cloud');
add_action('wp_ajax_nopriv_forgot_cloud', 'forgot_cloud');
function forgot_cloud()
{
    if (isset($_POST['action']) && $_POST['action'] === 'forgot_cloud') {
        $data = send_mail_cloud($_POST['action']);
        if ($data == 'Email sent successfully, check your inbox!') {
            wp_send_json_success($data);
        } else {
            wp_send_json_error("Error: " . $data);
        }
    }
}

add_action('wp_ajax_settings_media_cloud', 'settings_media_cloud');
add_action('wp_ajax_nopriv_settings_media_cloud', 'settings_media_cloud');
function settings_media_cloud()
{
    $del = isset($_POST["md-check-del"]) ? true : false;
    $status = isset($_POST["md-status"]) ? true : false;
    update_option('md-check-del', $del ? 1 : 0);
    update_option('md-status', $status ? 1 : 0);
}

// function createFileContentZip()
// {
//     function createPluginZip()
//     {
//         $plugin_dir = WP_PLUGIN_DIR;
//         $zip = new ZipArchive();
//         $zip_filename = WP_CONTENT_DIR . '/backup-file-edu2work/plugins.zip';

//         // Open the zip file for writing
//         if ($zip->open($zip_filename, ZipArchive::CREATE | ZipArchive::OVERWRITE) === true) {
//             addFilesToZip($plugin_dir, $zip, $plugin_dir);
//             // Close the zip archive
//             $zip->close();

//             wp_send_json_success($zip_filename);
//         } else {
//             echo 'Failed to create plugin zip file.';
//         }
//     }

//     function createThemesZip()
//     {
//         $themes_dir = WP_CONTENT_DIR . '/themes';
//         $zip = new ZipArchive();
//         $zip_filename = WP_CONTENT_DIR . '/backup-file-edu2work/themes.zip';

//         // Open the zip file for writing
//         if ($zip->open($zip_filename, ZipArchive::CREATE | ZipArchive::OVERWRITE) === true) {
//             addFilesToZip($themes_dir, $zip, $themes_dir);
//             // Close the zip archive
//             $zip->close();

//             wp_send_json_success($zip_filename);
//         } else {
//             echo 'Failed to create themes zip file.';
//         }
//     }

//     function createUploadZip()
//     {
//         $upload = wp_get_upload_dir();
//         $upload_dir = $upload['basedir'];
//         // var_dump($upload_dir);die;
//         $zip = new ZipArchive();
//         $zip_filename = WP_CONTENT_DIR . '/backup-file-edu2work/uploads.zip';

//         // Open the zip file for writing
//         if ($zip->open($zip_filename, ZipArchive::CREATE | ZipArchive::OVERWRITE) === true) {
//             addFilesToZip($upload_dir, $zip, $upload_dir);
//             // Close the zip archive
//             $zip->close();

//             wp_send_json_success($zip_filename);
//         } else {
//             echo 'Failed to create plugin zip file.';
//         }
//     }
// }
