jQuery(document).ready(function ($) {
	if (typeof linkCloud === "undefined") {
		linkCloud = last_resort_obj.linkCloud;
	}
	let omitted = /^((https?:)?(\/\/))?[^\/]+\/wp-content\/uploads\//;
	let currentDomain = window.location.hostname;
	document.addEventListener('DOMContentLoaded', function () {

		var observer = new MutationObserver(function (mutationsList) {
			for (var mutation of mutationsList) {
				if (mutation.type === 'attributes' && (mutation.attributeName === 'src' || mutation.attributeName === 'srcset')) {
					let element = mutation.target;
					let pattern = /^((https?:)?(\/\/))?[^\/]+\/wp-content\/uploads\/\d{4}\/\d{2}\//;
					if (mutation.attributeName === 'src') {
						if (!checkURL(element.getAttribute('src'))) {
							let src = element.getAttribute('src');
							let modifiedSrc = linkCloud + '/' + currentDomain + '/' + src.replace(omitted, '');
							if (checkURL(modifiedSrc)) {
								element.src = modifiedSrc;
							}
						}
					} else {
						if (!checkURL(element.getAttribute('srcset'))) {
							let srcset = element.getAttribute('srcset');
							let modifiedSrcset = linkCloud + '/' + currentDomain + '/' + srcset.replace(omitted, '');
							if (checkURL(modifiedSrcset)) {
								element.srcset = modifiedSrcset;
							}
						}

					}
				}
			}
		});

		// Start tracking changes in the DOM
		observer.observe(document, { attributes: true, attributeFilter: ['src', 'srcset'], subtree: true });


	});
	function checkURL(url) {
		let pattern = /^(https?:\/\/)?([\w.-]+)\.([a-z]{2,6}\.?)(\/[\w.-]*)*\/?$/;
		return pattern.test(url);
	}
	var count = 0;

	function LoadMediaError() {
		let pattern = /^((https?:)?(\/\/))?[^\/]+\/wp-content\/uploads\/\d{4}\/\d{2}\//;
		let omitted = /^((https?:)?(\/\/))?[^\/]+\/wp-content\/uploads\//;
		if (count < 2) {
			count++;
			$('*').each(function () {
				let backgroundImage = $(this).css('background-image');
				let inlineStyle = $(this).attr('style');

				if ((backgroundImage !== 'none' && backgroundImage !== '') || (inlineStyle && inlineStyle.includes('background-image'))) {
					let urlRegex = /url\("(.*)"\)/;
					let match = backgroundImage.match(urlRegex);
					if (match === null) {
						return;
					}
					let oldImageUrl = match[1];

					let mediaElement = new Image();
					let loadSuccess = false;

					mediaElement.onload = function () {
						loadSuccess = true;
					};

					mediaElement.addEventListener("error", function () {
						if (!loadSuccess) {
							let imageUrlValid = linkCloud + '/' + currentDomain + '/' + oldImageUrl.replace(omitted, '');
							if (checkURL(imageUrlValid)) {
								let newBackgroundImage = backgroundImage.replace(oldImageUrl, imageUrlValid);
								$(this).css('background-image', newBackgroundImage);
							}

						}
					});

					mediaElement.src = oldImageUrl;
				}
			});
			$("[src], [srcset], [data-lazy-src]").filter("img, video, audio").each(function () {
				if ($(this).attr("src")) {
					let srcValue = $(this).attr("src");

					if (pattern.test(srcValue) && $(this).prop('complete') && !$(this).prop('naturalWidth')) {
						let modifiedSrc = linkCloud + '/' + currentDomain + '/' + srcValue.replace(omitted, '');
						if (checkURL(modifiedSrc)) {
							$(this).attr("src", modifiedSrc);
						}
					}
				}

				// Thay đổi giá trị của thuộc tính 'srcset'
				if ($(this).attr("srcset")) {
					let srcsetValue = $(this).attr("srcset");
					if (pattern.test(srcsetValue) && $(this).prop('complete') && !$(this).prop('naturalWidth')) {
						let modifiedSrcset = linkCloud + '/' + currentDomain + '/' + srcsetValue.replace(omitted, '');
						if (checkURL(modifiedSrcset)) {
							$(this).attr("srcset", modifiedSrcset);
						}
					}


				}
				if ($(this).attr("data-lazy-src")) {
					let lazySrc = $(this).attr("data-lazy-src");
					if (pattern.test(lazySrc) && $(this).prop('complete')) {
						let modifiedLazySrc = linkCloud + '/' + currentDomain + '/' + lazySrc.replace(omitted, '');
						if (checkURL(modifiedLazySrc)) {
							let $element = $(this);

							let mediaElement;
							if ($element.is("img")) {
								mediaElement = new Image();
							} else if ($element.is("video")) {
								mediaElement = document.createElement("video");
							} else if ($element.is("audio")) {
								mediaElement = document.createElement("audio");
							}
							let loadSuccess = false;
							mediaElement.onload = function () {
								loadSuccess = true;
							};

							mediaElement.addEventListener("error", function () {
								if (!loadSuccess) {
									$element.attr("data-lazy-src", modifiedLazySrc);
								}
							});
							mediaElement.src = lazySrc;

						}
					}
				}
			});
			setTimeout(LoadMediaError, 3000);
		}
	}
	LoadMediaError();
});
