jQuery(document).ready(function ($) {
  function hideLog(log, time) {
    setTimeout(function () {
      log.hide();
    }, time);
  }

  function showLog(log, time) {
    setTimeout(function () {
      log.fadeIn();
    }, time);
  }
  var restoreCheck = false;
  var checkDatabase = false;
  $(document).on("click", ".database-cloud", function () {
    // Restore Database button click event handling code
    var backupFile = $(this).attr("data-backup");
    var downloadFile = $(this).attr("data-cloud");
    var dataDelete = $(this).attr("data-delete");
    var check = confirm("Are you certain about restore the database?");
    if (check) {
      $(".loading-restore").show();
      $(".overlay").show();
      $("#blur").addClass("blur");
      $(".database-restore").show();
      $(".restore-1").hide();
      $.ajax({
        data: {
          action: "database_cloud",
          downloadFile: downloadFile,
          backupFile: backupFile,
          dataDelete: dataDelete,
        },
        url: ajaxurl,
        method: "POST",
        success: function (result) {
          if (result.success) {
            $(".loading-restore").hide();
            $(".overlay").hide();
            $("#blur").removeClass("blur");
            $(".database-restore").hide();

            Swal.fire({
              title: "Success:",
              text: "Restore database success!",
              icon: "success",
              allowOutsideClick: false,
              showConfirmButton: true,
              onBeforeOpen: () => {
                Swal.showLoading();
              },
            }).then((result) => {
              if (result.isConfirmed) {
                window.location.reload();
              }
            });
          } else {
            $(".loading-restore").hide();
            $(".overlay").hide();
            $("#blur").removeClass("blur");
            $(".database-restore").hide();
            Swal.fire({
              title: "Failed:",
              html: result.data.replace(/\n/g, "<br>"),
              icon: "error",
              allowOutsideClick: false,
              showConfirmButton: true,
              onBeforeOpen: () => {
                Swal.showLoading();
              },
            });
          }
        },
      });
    }
  });
  // API
  $(document).on("click", ".database-api", function () {
    // Restore Database button click event handling code
    var backupFile = $(this).attr("data-backup");
    var downloadFile = $(this).attr("data-cloud");
    var dataDelete = $(this).attr("data-delete");
    var hostName = $(this).attr("data-name");
    var domain = window.location.hostname;
    var href = "https://" + domain;
    if (hostName !== domain) {
      var check = confirm(
        "You about to cloning another website to this domain! \nAre you certain to restore?"
      );
    } else {
      var check = confirm("Are you certain about restore the database?");
    }
    if (check) {
      $(".loading-restore").show();
      $(".overlay").show();
      $("#blur").addClass("blur");
      $(".database-restore").show();
      $(".restore-1").hide();
      $.ajax({
        data: {
          action: "database_cloud",
          downloadFile: downloadFile,
          backupFile: backupFile,
          dataDelete: dataDelete,
        },
        url: ajaxurl,
        method: "POST",
        success: function (result) {
          if (result.success) {
            $.ajax({
              data: {
                action: "change_url",
                href: href,
              },
              url: ajaxurl,
              method: "POST",
              success: function (response) {
                restoreCheck = true;
                $(".loading-restore").hide();
                $(".overlay").hide();
                $("#blur").removeClass("blur");
                $(".database-restore").hide();
                if (response.success) {
                  Swal.fire({
                    title: "Success:",
                    text: "Restore database success!",
                    icon: "success",
                    allowOutsideClick: false,
                    showConfirmButton: true,
                    onBeforeOpen: () => {
                      Swal.showLoading();
                    },
                  }).then((result) => {
                    if (result.isConfirmed) {
                      // window.location.reload();
                    }
                  });
                } else {
                  Swal.fire({
                    title: "Failed:",
                    html: "Failed to restore database!",
                    icon: "error",
                    allowOutsideClick: false,
                    showConfirmButton: true,
                    onBeforeOpen: () => {
                      Swal.showLoading();
                    },
                  });
                }
              },
            });
          } else {
            $(".loading-restore").hide();
            $(".overlay").hide();
            $("#blur").removeClass("blur");
            $(".database-restore").hide();

            Swal.fire({
              title: "Failed:",
              html: result.data.replace(/\n/g, "<br>"),
              icon: "error",
              allowOutsideClick: false,
              showConfirmButton: true,
              onBeforeOpen: () => {
                Swal.showLoading();
              },
            });
          }
        },
      });
    }
  });

  $(document).on("click", ".restore-cloud", function () {
    // Restore Database button click event handling code
    var backupFile = $(this).attr("data-backup");
    var downloadFile = $(this).attr("data-cloud");

    var check = confirm(
      "Please consider to restore database before restore the server"
    );

    if (check) {
      $.ajax({
        data: {
          action: "server_cloud",
          downloadFile: downloadFile,
          backupFile: backupFile,
        },
        url: ajaxurl,
        method: "POST",
        beforeSend: function (xhr) {
          $(".loading-restore").show();
          $(".overlay").show();
          $("#blur").addClass("blur");
          hideLog($(".restore-1"), 4000);
          showLog($(".restore-2"), 4000);
          hideLog($(".restore-2"), 8000);
          showLog($(".restore-3"), 8000);
          hideLog($(".restore-3"), 12000);
          showLog($(".restore-4"), 12000);
          hideLog($(".restore-4"), 16000);
          showLog($(".restore-5"), 16000);
        },
        success: function (result) {
          $(".loading-restore").hide();
          $(".overlay").hide();
          $("#blur").removeClass("blur");

          if (result.success) {
            Swal.fire({
              title: "Success:",
              text: "Restore server success!",
              icon: "success",
              allowOutsideClick: false,
              showConfirmButton: true,
              onBeforeOpen: () => {
                Swal.showLoading();
              },
            }).then((result) => {
              if (result.isConfirmed) {
                window.location.reload();
              }
            });
          } else {
            Swal.fire({
              title: "Error:",
              text: "An error occurred while restore server from cloud file. Contact us for assistance!",
              icon: "error",
              allowOutsideClick: false,
              showConfirmButton: true,
              onBeforeOpen: () => {
                Swal.showLoading();
              },
            });
          }
        },
      });
    }
  });
  // API
  $(document).on("click", ".restore-api", function () {
    // Restore Database button click event handling code
    var backupFile = $(this).attr("data-backup");
    var downloadFile = $(this).attr("data-cloud");
    var hostName = $(this).attr("data-name");
    var domain = window.location.hostname;
    if (hostName !== domain) {
      var check = confirm(
        "You about to cloning another website to this domain! \nPlease restore Database first!"
      );
      if (check) {
        checkDatabase = true;
      }
    } else {
      var check = confirm("Are you certain about restore the Server?");
      if (check) {
        restoreCheck = true;
        checkDatabase = true;
      }
    }
    if (check) {
      if (restoreCheck && checkDatabase) {
        $.ajax({
          data: {
            action: "server_cloud",
            downloadFile: downloadFile,
            backupFile: backupFile,
          },
          url: ajaxurl,
          method: "POST",
          beforeSend: function (xhr) {
            $(".loading-restore").show();
            $(".overlay").show();
            $("#blur").addClass("blur");
            hideLog($(".restore-1"), 4000);
            showLog($(".restore-2"), 4000);
            hideLog($(".restore-2"), 8000);
            showLog($(".restore-3"), 8000);
            hideLog($(".restore-3"), 12000);
            showLog($(".restore-4"), 12000);
            hideLog($(".restore-4"), 16000);
            showLog($(".restore-5"), 16000);
          },
          success: function (result) {
            $(".loading-restore").hide();
            $(".overlay").hide();
            $("#blur").removeClass("blur");

            if (result.success) {
              Swal.fire({
                title: "Success:",
                text: "Restore server success!",
                icon: "success",
                allowOutsideClick: false,
                showConfirmButton: true,
                onBeforeOpen: () => {
                  Swal.showLoading();
                },
              }).then((result) => {
                if (result.isConfirmed) {
                  window.location.reload();
                }
              });
            } else {
              Swal.fire({
                title: "Error:",
                text: "An error occurred while upload file to cloud. Contact us for assistance!",
                icon: "error",
                allowOutsideClick: false,
                showConfirmButton: true,
                onBeforeOpen: () => {
                  Swal.showLoading();
                },
              });
            }
          },
        });
      } else {
        Swal.fire({
          title: "Error:",
          text: "Please restore database before restore server!",
          icon: "error",
          allowOutsideClick: false,
          showConfirmButton: true,
          onBeforeOpen: () => {
            Swal.showLoading();
          },
        });
      }
    }
  });
  $(document).on("click", "#scheduled", function () {
    // Restore Database button click event handling code
    var select = $("#select").val();
    $.ajax({
      data: {
        action: "scheduled",
        scheduled: select,
      },
      url: ajaxurl,
      method: "POST",
      success: function (response) {
        Swal.fire({
          title: "Success:",
          text: "Save changed successfully!",
          icon: "success",
          allowOutsideClick: false,
          showConfirmButton: true,
          onBeforeOpen: () => {
            Swal.showLoading();
          },
        });
      },
    });
  });
  // TODO: Delete this
  // $(document).on("click", ".delete-cloud", function () {
  //   // Restore Database button click event handling code
  //   var id = $(this).attr("data-id");
  //   $.ajax({
  //     data: {
  //       action: "delete_cloud",
  //       id: id,
  //     },
  //     url: ajaxurl,
  //     method: "POST",
  //     success: function (response) {
  //       Swal.fire({
  //         title: "Success:",
  //         text: "Delete successfully!",
  //         icon: "success",
  //         allowOutsideClick: false,
  //         showConfirmButton: true,
  //         onBeforeOpen: () => {
  //           Swal.showLoading();
  //         },
  //       });
  //     },
  //   });
  // });
});
