jQuery(document).ready(function ($) {
  /*
	By Osvaldas Valutis, www.osvaldas.info
	Available for use under the MIT License
*/

  "use strict";

  (function (document, window, index) {
    var inputs = document.querySelectorAll(".inputfile");
    Array.prototype.forEach.call(inputs, function (input) {
      var label = input.nextElementSibling,
        labelVal = label.innerHTML;

      input.addEventListener("change", function (e) {
        var fileName = "";
        if (this.files && this.files.length > 1)
          fileName = (this.getAttribute("data-multiple-caption") || "").replace(
            "{count}",
            this.files.length
          );
        else fileName = e.target.value.split("\\").pop();

        if (fileName) label.querySelector("span").innerHTML = fileName;
        else label.innerHTML = labelVal;
      });

      // Firefox bug fix
      input.addEventListener("focus", function () {
        input.classList.add("has-focus");
      });
      input.addEventListener("blur", function () {
        input.classList.remove("has-focus");
      });
    });
  })(document, window, 0);

  function clickLabel(file_click, info) {
    $(file_click).click(function (e) {
      $(info).click();
    });
  }

  $("#uploadLocal").submit(function (e) {
    e.preventDefault();

    clickLabel("#file-label-server", "#file-server");
    clickLabel("#file-label-database", "#file-database");

    $("#file-server").change(function () {
      if ($(this).prop("files").length > 0) {
        $("#file-server-error").hide();
      }
    });

    $("#file-database").change(function () {
      if ($(this).prop("files").length > 0) {
        $("#file-database-error").hide();
      }
    });

    var fileServer = $("#file-server").prop("files")[0];
    var fileDatabase = $("#file-database").prop("files")[0];
    var formData = new FormData();
    formData.append("fileServer", fileServer);
    formData.append("fileDatabase", fileDatabase);
    formData.append("action", "restore_upload");
    console.log(formData);
    if (fileServer && fileDatabase) {
      $.ajax({
        url: ajaxurl,
        processData: false,
        contentType: false,
        method: "POST",
        data: formData,
        success: function (result) {
          console.log(result);
        },
      });
    } else {
      if ($("#file-server").prop("files").length === 0) {
        $("#file-server-error").show();
      }
      if ($("#file-database").prop("files").length === 0) {
        $("#file-database-error").show();
      }
    }
  });
});
