jQuery(document).ready(function ($) {
  if (typeof ajaxurl === "undefined") {
    ajaxurl = Backup_obj.ajaxurl;
  }
  if (typeof img === "undefined") {
    img = Backup_obj.img;
  }
  console.log("ok");
  $(".nav-tab").on("click", function (e) {
    e.preventDefault();
    var targetTab = $(this).attr("href");
    $(".tab-content").removeClass("active");
    $(targetTab).addClass("active");
    $(".nav-tab").removeClass("nav-tab-active");
    $(this).addClass("nav-tab-active");
  });

  var showDiv = $("#showDiv").attr("data-show");
  if (showDiv) {
    $(".div-show").hide();
  }

  $("#check_key").submit(function (e) {
    e.preventDefault();

    $(".spin-confirm").show(); // Show the spinner immediately
    $(".send-confirm").hide();
    const formData = new FormData(e.currentTarget);
    formData.append("action", "check_key_ajax_function");
    axios
      .post(ajaxurl, formData)
      .then(function (response) {
        if (response.data.data == "Successful authentication") {
          sessionStorage.setItem(
            "successMessage",
            "Successful authentication!"
          );
          window.location.reload();
        } else {
          $(".spin-confirm").hide(); // Show the spinner immediately
          $(".send-confirm").show();

          Swal.fire({
            title: "Error:",
            text: response.data.data,
            icon: "error",
            allowOutsideClick: false,
            showConfirmButton: true,
            onBeforeOpen: () => {
              Swal.showLoading();
            },
          });
        }
      })
      .catch(function (error) {});
  });

  function customAlert(message) {
    var deferred = $.Deferred();
    window.alert(message);

    $(window).on("focus", function () {
      deferred.resolve();
    });

    return deferred.promise();
  }

  function hideLog(log, time) {
    setTimeout(function () {
      log.hide();
    }, time);
  }

  function showLog(log, time) {
    setTimeout(function () {
      log.fadeIn();
    }, time);
  }
  var handle = true;
  $("#server").click(function (e) {
    if (handle) {
      handle = false;
      $.ajax({
        data: {
          action: "backup_database",
        },
        url: ajaxurl,
        method: "POST",
        beforeSend: function (xhr) {
          $(".progress-bar").css("width", 0);
          $("#handle").show();
          var get_zip = $(".get-zip");
          get_zip.show();
          var zip_show = `
            <div class="all-zip" style='display: none;'>
                <h5 class="zip-1 font-monospace" style='display: none;'>Creating database zip...</h5>
                <h5 class="zip-2 font-monospace" style='display: none;'>Adding plugins file to zip...</h5>
                <h5 class="zip-3 font-monospace" style='display: none;'>Adding themes file to zip...</h5>
                <h5 class="zip-4 font-monospace" style='display: none;'>Adding uploads file to zip...</h5>
                <h5 class="zip-5 font-monospace" style='display: none;'>Creating others zip files.(Please wait...)</h5>
            </div>
            `;
          get_zip.html(zip_show);
        },
        success: function (result) {
          if (result.success) {
            // console.log(result);
            $(".progress-bar-container").show();
            var progressBarWidth = 35;
            $(".progress-bar").css("width", progressBarWidth + "%");
            $("#handle").hide();
            var dataFile = result.data.name;
            var fileSize = result.data.size;
            var path = result.data.path;
            var all_zip = $(".all-zip");
            var zip_1 = $(".zip-1");
            var zip_2 = $(".zip-2");
            var zip_3 = $(".zip-3");
            var zip_4 = $(".zip-4");
            var zip_5 = $(".zip-5");
            // console.log(zip_1);
            all_zip.show();
            $(".zip-1").show();
            hideLog(zip_1, 4000);
            showLog(zip_2, 4000);
            hideLog(zip_2, 8000);
            showLog(zip_3, 8000);
            hideLog(zip_3, 12000);
            showLog(zip_4, 12000);
            hideLog(zip_4, 16000);
            showLog(zip_5, 16000);
            $.ajax({
              data: {
                action: "backup_server",
                path: path,
                fileSize: fileSize,
              },
              url: ajaxurl,
              method: "POST",
              beforeSend: function (xhr) {
                setTimeout(function () {
                  var progressBarWidth = 70;
                  $(".progress-bar").css("width", progressBarWidth + "%");
                }, 8000);
              },
              success: function (response) {
                handle = true;
                var all_zip = $(".all-zip");
                var progressBarWidth = 100;
                var serverFile = response.data;
                $(".progress-bar").css("width", progressBarWidth + "%");
                $(".progress-bar-container").fadeOut();
                $("#triggerModal").click();
                $("#message").remove();
                all_zip.remove();
                $(".reload-table").load(location.href + " .reload-table");
              },
            });
          }
        },
      });
    }
  });

  $(document).on("click", ".restore", function () {
    // Restore Server button click event handling code
    var backupFile = $(this).attr("data-backup");
    var check = confirm(
      "Please consider to restore database before restore the server!"
    );

    if (check) {
      $.ajax({
        data: {
          action: "restore_server",
          backupFile: backupFile,
        },
        url: ajaxurl,
        method: "POST",
        beforeSend: function (xhr) {
          $(".loading-restore").show();
          $(".overlay").show();
          $("#blur").addClass("blur");
          hideLog($(".restore-1"), 4000);
          showLog($(".restore-2"), 4000);
          hideLog($(".restore-2"), 8000);
          showLog($(".restore-3"), 8000);
          hideLog($(".restore-3"), 12000);
          showLog($(".restore-4"), 12000);
          hideLog($(".restore-4"), 16000);
          showLog($(".restore-5"), 16000);
        },
        success: function (result) {
          $(".loading-restore").hide();
          $(".overlay").hide();
          if (result.success) {
            Swal.fire({
              title: "Success:",
              text: "Restore server success!",
              icon: "success",
              allowOutsideClick: false,
              showConfirmButton: true,
              onBeforeOpen: () => {
                Swal.showLoading();
              },
            }).then((result) => {
              if (result.isConfirmed) {
                window.location.reload();
              }
            });
          }
        },
      });
    }
  });

  $(document).on("click", ".database", function () {
    // Restore Database button click event handling code
    var backupFile = $(this).attr("data-backup");
    var dataDelete = $(this).attr("data-delete");
    var check = confirm("Are you certain about restoring the database?");
    if (check) {
      $(".loading-restore").show();
      $(".overlay").show();
      $("#blur").addClass("blur");
      $(".database-restore").show();
      $(".restore-1").hide();
      $.ajax({
        data: {
          action: "restore_database",
          backupFile: backupFile,
          dataDelete: dataDelete,
        },
        url: ajaxurl,
        method: "POST",
        success: function (result) {
          console.log(result);
          if (result.success) {
            $(".loading-restore").hide();
            $(".overlay").hide();
            $("#blur").removeClass("blur");
            $(".database-restore").hide();

            Swal.fire({
              title: "Success:",
              text: "Restore database success!",
              icon: "success",
              allowOutsideClick: false,
              showConfirmButton: true,
              onBeforeOpen: () => {
                Swal.showLoading();
              },
            }).then((response) => {
              if (response.isConfirmed) {
                window.location.reload();
              }
            });
          } else {
            $(".loading-restore").hide();
            $(".overlay").hide();
            $("#blur").removeClass("blur");
            $(".database-restore").hide();

            Swal.fire({
              title: "Failed:",
              html: result.data.replace(/\n/g, "<br>"),
              icon: "error",
              allowOutsideClick: false,
              showConfirmButton: true,
              onBeforeOpen: () => {
                Swal.showLoading();
              },
            });
          }
        },
      });
    }
  });

  $(document).on("click", ".delete", function () {
    // Delete Backup button click event handling code
    var deleteFile = $(this).attr("data-id");
    var row = $(this).closest("tr");
    var check = confirm("Are you certain about deleting this backup?");
    if (check) {
      $.ajax({
        data: {
          action: "delete_backup",
          deleteFile: deleteFile,
        },
        url: ajaxurl,
        method: "POST",
        success: function (result) {
          console.log(result.success);
          if (result.success) {
            Swal.fire({
              title: "Success:",
              html: "<p class='m-2 fs-5'>2 Files deleted</p>Delete success!",
              icon: "success",
              allowOutsideClick: false,
              showConfirmButton: true,
              onBeforeOpen: () => {
                Swal.showLoading();
              },
            });
            row.fadeOut();
          }
        },
      });
    }
  });

  $(document).on("click", ".cloud", function () {
    // Delete Backup button click event handling code

    var token = $(this).attr("data-token");
    if (!token) {
      Swal.fire({
        title: "Warning:",
        text: "Signup to get token before upload to cloud!",
        icon: "warning",
        allowOutsideClick: false,
        showConfirmButton: true,
        onBeforeOpen: () => {
          Swal.showLoading();
        },
      });
      return;
    }
    var path = $(this).attr("data-path");
    var api = $(this).attr("data-api");
    var size = $(this).attr("data-size");
    var created = $(this).attr("data-created");
    var check = confirm("Upload to Edu2Work Cloud?");
    if (check) {
      $(this).find(".cloud-api").hide();
      $(this).find(".spin-api").show();
      $.ajax({
        data: {
          action: "cloud_backup",
          path: path,
          api: api,
          size: size,
          created: created,
        },
        url: ajaxurl,
        method: "POST",
        success: function (result) {
          console.log(result);
          $(".reload-table").load(location.href + " .reload-table");
          if (result.success) {
            Swal.fire({
              title: "Success:",
              text: "Upload to cloud success!",
              icon: "success",
              allowOutsideClick: false,
              showConfirmButton: true,
              onBeforeOpen: () => {
                Swal.showLoading();
              },
            });
          } else {
            Swal.fire({
              title: "Error:",
              html: "<p class='m-2 fs-5'>Upload to cloud Failed!</p>Check your Cloud Storage or try again later.",
              icon: "error",
              allowOutsideClick: false,
              showConfirmButton: true,
              onBeforeOpen: () => {
                Swal.showLoading();
              },
            });
          }
        },
      });
    }
  });
  $(document).on("click", ".local", function () {
    Swal.fire({
      title: "Warning:",
      html: "<p class='m-2 fs-5'>Your Cloud Storage already full!</p> Contact us to increase Your Cloud Storage capacity.",
      icon: "warning",
      allowOutsideClick: false,
      showConfirmButton: true,
      onBeforeOpen: () => {
        Swal.showLoading();
      },
    });
  });

  $(document).on("submit", "#settings_mediaTab", function (e) {
    e.preventDefault();
    const formData = new FormData(e.currentTarget);
    formData.append("action", "settings_media_cloud");
    axios
      .post(ajaxurl, formData)
      .then(function (response) {
        var isChecked = $("#md-status").is(":checked");
        if (isChecked) {
          $("#Sync_media").prop("disabled", false);
        } else {
          $("#Sync_media").prop("disabled", true);
        }
        Swal.fire({
          title: "Success:",
          html: "Save change Success!",
          icon: "success",
          allowOutsideClick: false,
          showConfirmButton: true,
          onBeforeOpen: () => {
            Swal.showLoading();
          },
        });
      })
      .catch(function (error) {});
    // jQuery('#exampleModal').modal('show');
  });

  $("#Sync_media").click(function (e) {
    // e.preventDefault();
    $("#upload_media").prop("disabled", true);
    $("#recover_media").prop("disabled", true);
    $("#delete_media").prop("disabled", true);

    $.ajax({
      data: {
        action: "get_file_media_cloud",
      },
      url: ajaxurl,
      method: "post",
      beforeSend: function (xhr) {},
      success: function (response) {
        if (response.success) {
          $("#upload_media").prop("disabled", false);
          $("#recover_media").prop("disabled", false);
          $("#delete_media").prop("disabled", false);

          postajax(response);
          //                     if (requestAjax) {
          //                             //console.log("done");
          //                             return;
          //                         }
        } else {
          //                         alert("NOTICE: Please Upload & Setup Favicon after Sync complete!");

          $("#upload_media").prop("disabled", true);
          $("#recover_media").prop("disabled", false);
          $("#delete_media").prop("disabled", false);

          alert("Empty folder, no need to bring it up");
          $(".check-load").fadeOut();
          $(".check-warning").show();
        }
      },
    });
  });

  function postajax(response) {
    var data_post = response.data;
    var total = `<span class='fs-6 fst-italic fw-bold total-file'>${data_post.length} files to upload</span>`;
    $("#data-passed").html("");
    $("#total").html(total);
    $(".check-load").hide();
    $(".check-success").show();
    jQuery("#mediaModal").modal("show");
    $("#upload_media").click(function (e) {
      $("#delete_media").prop("disabled", true);
      $("#recover_media").prop("disabled", true);
      e.preventDefault();
      $(".loading").fadeIn();
      var totalCount = data_post.length;
      var fileShow = data_post.length;
      var count = 0;
      var path = data_post[count];
      var n = 0;
      function sendRequest(path) {
        $.ajax({
          data: {
            action: "post_media_function",
            path: path,
          },
          url: ajaxurl,
          method: "post",
          beforeSend: function (xhr) {},
          success: function (result) {
            $(".loading").fadeOut();
            count++;
            var progressBarWidth = (count / totalCount) * 100;
            if (count / totalCount == 1) {
              $("#delete_media").prop("disabled", false);
              $("#recover_media").prop("disabled", false);
            }
            $(".progress-bar").css("width", progressBarWidth + "%");
            if (result.data) {
              image = result.data;
              $("#data-passed").append(image);
              var each = `<span class='fs-6 fst-italic fw-bold each-image'>${count}/</span>`;
              $("#each").html(each);
              if (count < totalCount) {
                sendRequest(data_post[count]);
              } else {
                var each = `<span class='fs-6 text-success fw-bold'>Upload completed/</span>`;
                $("#each").html(each);
              }
            }
          },
          error: function (xhr, status, error) {
            n++;
            if (n <= 5) {
              sendRequest(data[count]);
            } else {
              console.log(xhr.responseText);
              console.log(status);
              console.log(error);
            }
          },
        });
      }
      sendRequest(data_post[count]);

      $("#upload_media").prop("disabled", true);
    });
  }

  // Delete
  $("#delete_media").click(function (e) {
    e.preventDefault();
    $(".check-load").show();
    var dell = confirm(
      "We will only delete files you already have on Media Cloud, avoiding loss of your data!!"
    );
    var delAll = confirm("Are you sure to delete all?");
    if (dell) {
      if (delAll) {
        $("#delete_media").prop("disabled", true);
        Swal.fire({
          title: "Processing...",
          text: "Please wait until processing is completed!!!",
          allowOutsideClick: false,
          showConfirmButton: false,
          onBeforeOpen: () => {
            Swal.showLoading();
          },
        });
        $.ajax({
          data: {
            action: "delete_media_cloud",
          },
          url: ajaxurl,
          method: "post",
          beforeSend: function (xhr) {},
          success: function (result) {
            if (result.success) {
              Swal.close();
              $(".get-image").hide();
              var noti = `<p class='fs-6 fst-italic fw-bold total-file'>All files Deleted</p>`;
              $("#each").html(noti);
            } else {
              Swal.close();
              $("#delete_media").click();
            }
            $(".check-load").hide();
            $("#total").hide();
            $("#data-passed").html("");
          },
        });
      }
    }
  });

  //Recover
  $("#recover_media").click(function (e) {
    e.preventDefault();
    $(".check-load").show();
    $("#delete_media").prop("disabled", false);
    Swal.fire({
      title: "Processing...",
      text: "Please wait until processing is completed!!!",
      allowOutsideClick: false,
      showConfirmButton: false,
      onBeforeOpen: () => {
        Swal.showLoading();
      },
    });

    $.ajax({
      data: {
        action: "recover_cloud",
      },
      url: ajaxurl,
      method: "post",
      success: function (result) {
        if (result.success) {
          if (result.data == "Start_again") {
            $("#recover_media").click();
          } else {
            Swal.close();
            $("#Sync_media").click();
            $("#delete_media").prop("disabled", false);
            $("#fileProgress").show();
            $(".get-image").hide();
            $(".check-warning").hide();
            var noti = `<p class='fs-6 fst-italic fw-bold text-success'>Recover Completed</p>`;
            $("#each").html(noti);
            $("#total").hide();
          }
        } else {
          alert("Failed to Recover");
        }
        $(".check-load").hide();
      },
    });
  });
});
