<?php
include_once 'ajax.php';
include_once 'get_size.php';
function autoZip()
{
    function autoDatabase()
    {
        // Database configuration
        $db_host = 'localhost';
        $db_name = DB_NAME;
        $db_user = DB_USER;
        $db_password = DB_PASSWORD;
        // Add in db
        global $wpdb;
        $table_name = $wpdb->prefix . 'backup_edu';
        $url_content = content_url();
        // $sql = '';
        // Path to store the database backup file
        $backup_dir = BACKUP_DATA;
        $database_filename = 'db-'  . get_domain_edu() . '-' . current_time_edu() . '.sql';
        // Generate the database backup file
        $command = "mysqldump --host={$db_host} --user={$db_user} --password={$db_password} {$db_name} --ignore-table={$db_name}.{$table_name} > {$backup_dir}{$database_filename}";
        $output = [];
        $return_var = 0;
        exec($command, $output, $return_var);

        // Create a zip archive for the database file
        $zip = new ZipArchive();
        $zip_filename = BACKUP_DATA . 'db-' . get_domain_edu() . '-' . current_time_edu() . '.gz';
        $file_name = basename($zip_filename);
        $file_upload = get_host_edu() . '/backup' . '/database/' . basename($zip_filename);
        $url_api = $url_content . '/backup-file-edu2work/' . $file_name;
        // Open the zip file for writing
        if ($zip->open($zip_filename, ZipArchive::CREATE | ZipArchive::OVERWRITE) === true) {
            // Add the database file to the zip
            if ($zip->addFile("{$backup_dir}{$database_filename}", $database_filename)) {
                $zip->close();
                // FIXME: Run filesize after zip close;
                $file_size = filesize($zip_filename);
                // $file_extension = pathinfo($zip_filename, PATHINFO_EXTENSION);
                $file_created = date("Y-m-d H:i:s", filemtime($zip_filename));
                $cloudLink = get_option('md-cloud-link');
                $public_url = $cloudLink . '/' . $file_upload;
                $sql_backup = "INSERT INTO $table_name (file_path_db, file_download_db, file_cloud_db, created_at) VALUES ( '$zip_filename', '$url_api', '$public_url', '$file_created')";

                if (connect()->query($sql_backup)) {
                    unlink("{$backup_dir}{$database_filename}");

                    $file_send = [
                        'name' => $file_name,
                        'path' => $zip_filename,
                        'size' => $file_size,
                        'download' => $url_api,
                        'cloud' => $public_url,
                        'modified' => $file_created,
                        'url' => $url_api
                    ];
                    return $file_send;
                } else {
                    echo "Error: $sql_backup " . mysqli_error(connect());
                }
            }
        } else {
            echo 'Failed to create database zip file.';
        }
    }
    function autoWP()
    {
        $url_content = content_url();
        // wp_send_json_success($url_content);
        $info_database = autoDatabase();
        $file_database = $info_database['path'];
        $file_size_db = $info_database['size'];

        // var_dump($info_database['path']);die;
        global $wpdb;
        $table_name = $wpdb->prefix . 'backup_edu';

        // TODO: Uncomment to zip all file wp
        $WP_dir = ABSPATH;

        $zip = new ZipArchive();
        $zip_filename = BACKUP_DATA . 'wp-' . get_domain_edu() . '-' . current_time_edu() . '.zip';

        $file_name = basename($zip_filename);
        $file_upload = get_host_edu() . '/backup' . '/server/' . basename($zip_filename);

        $url_api = $url_content . '/backup-file-edu2work/' . $file_name;
        // Open the zip file for writing
        if ($zip->open($zip_filename, ZipArchive::CREATE | ZipArchive::OVERWRITE) === true) {
            addFilesToZip($WP_dir, $zip, $WP_dir);
            // Close the zip archive
            $zip->close();
            $file_size = filesize($zip_filename);
            $file_created = date("Y-m-d H:i:s", filemtime($zip_filename));
            //$bucket_name = 'servertoidayhoc';

            //$public_url = 'https://f005.backblazeb2.com/file/' . $bucket_name . '/' . $file_upload;
            $cloudLink = get_option('md-cloud-link');
            $public_url = $cloudLink . '/' . $file_upload;
            $sql_backup = "UPDATE $table_name SET file_path_server = '$zip_filename', file_download_server = '$url_api', file_cloud_server = '$public_url', file_size = '$file_size_db,$file_size', auto = 'check' WHERE file_path_db = '$file_database'";

            if (connect()->query($sql_backup)) {
                $msg = 'zip success';
                echo "$msg";
            } else {
                echo "Error: $sql_backup " . mysqli_error(connect());
            }
        } else {
            echo 'Failed to create themes zip file.';
        }
    }
    autoWP();
}

function auto_backup()
{
    $api_key = get_option('md_edu_key');
    if ($api_key) {
        //$bucket_name = 'servertoidayhoc';
        $cloudLink = get_option('md-cloud-link');
        global $wpdb;
        $table_name = $wpdb->prefix . 'backup_edu';
        $check = "SELECT * FROM $table_name ORDER BY id DESC LIMIT 1";
        $result = connect()->query($check);
        $row = mysqli_fetch_array($result);
        $remain = @remain_cloud();
        $allow = allow_cloud();
        if ($row) {
            if (@$remain > $allow) {
                $date = date('Y-m-d');
                if (!strpos($row['file_path_db'], $date)) {
                    autoZip();
                    $check_api = "SELECT * FROM $table_name ORDER BY id DESC LIMIT 1";
                    $result_api = connect()->query($check_api);
                    $row_api = mysqli_fetch_array($result_api);

                    $file_name = [$row_api['file_path_db'], $row_api['file_path_server']];
                    $url_api = [$row_api['file_download_db'], $row_api['file_download_server']];
                    $file_size = explode(',', $row_api['file_size']);
                    $file_created = $row_api['created_at'];
                    $path_cloud = ['database', 'server'];
                    // get file to delete
                    $current_date = date('Y-m-d');
                    $previous_date = date('Y-m-d', strtotime('-3 days', strtotime($current_date)));

                    $sql_file = "SELECT * FROM $table_name WHERE auto = 'check' ORDER BY id ASC";

                    $result_cloud = connect()->query($sql_file);
                    $row_cloud = mysqli_fetch_array(connect()->query($sql_file));
                    $path_delete = [$row_cloud['file_path_db'], $row_cloud['file_path_server']];
                    $id_delete = $row_cloud['id'];

                    $all_file = basename($file_name[0]) . '|' . basename($file_name[1]);
                    $all_size = intval($file_size[0] + $file_size[1]);
                    $file_cloud_db = $cloudLink . '/' . get_host_edu() . '/backup' . "/$path_cloud[0]/" . basename($file_name[0]);
                    $file_cloud_server = $cloudLink . '/' . get_host_edu() . '/backup' . "/$path_cloud[1]/" . basename($file_name[1]);
                    $url_cloud = $file_cloud_db . '|' . $file_cloud_server;

                    for ($i = 0; $i < count($file_name); $i++) {
                        $file_upload = get_host_edu() . '/backup' . "/$path_cloud[$i]/" . basename($file_name[$i]);
                        $url = $url_api[$i];
                        //$public_url = 'https://f005.backblazeb2.com/file/' . $bucket_name . '/' . $file_upload;
                        $public_url = $cloudLink . '/' . $file_upload;
                        $file_info = [
                            'name' => $all_file,
                            'size' => $file_size[$i],
                            'size_return' => $all_size,
                            'modified' => $file_created,
                            'url' => $public_url,
                            'url_cloud' => $url_cloud
                        ];
                        
                        if ($result_cloud->num_rows > 3) {
                            $file_delete = get_host_edu() . "/backup" . "/$path_cloud[$i]/" . basename($path_delete[$i]);
                            check_key_ajax_function($file_delete, null, '', 'delete_file_cloud');
                            $sql_delete = "DELETE FROM $table_name WHERE id = $id_delete";
                            if (connect()->query($sql_delete)) {
                                echo 'delete success';
                            } else {
                                echo "Error: $sql_delete " . mysqli_error(connect());
                            }
                        }

                        $file_db = $file_name[0];

                        if ($all_size < $remain) {
                            $upload = check_key_ajax_function($file_upload, $url, $file_info, 'cloud_backup');
                            if ($upload == 'Complete push up.' || $upload == NULL) {
                                $sql_cloud = "UPDATE $table_name SET file_check = 'cloud' WHERE file_path_db = '$file_db'";
                                if (connect()->query($sql_cloud)) {
                                    echo 'add cloud success';
                                } else {
                                    echo "Error: $sql_cloud " . mysqli_error(connect());
                                }
                            } else {
                                unlink($file_name[0]);
                                unlink($file_name[1]);
                                wp_send_json_error('Storage 2 full');
                            };
                        } else {
                            unlink($file_name[0]);
                            unlink($file_name[1]);
                            echo 'Storage 3 full';
                        }
                    };
                    if ($upload == 'Complete push up.' || $upload == NULL) {
                        unlink($file_name[0]);
                        unlink($file_name[1]);
                    };
                } else {
                    echo 'exist';
                };
            } else {
                echo 'Storage full';
            }
        } else {

            autoZip();
            $check_api = "SELECT * FROM $table_name ORDER BY id DESC LIMIT 1";
            $result_api = connect()->query($check_api);
            $row_api = mysqli_fetch_array($result_api);

            $file_name = [$row_api['file_path_db'], $row_api['file_path_server']];
            $url_api = [$row_api['file_download_db'], $row_api['file_download_server']];
            $file_size = explode(',', $row_api['file_size']);
            $file_created = $row_api['created_at'];
            $path_cloud = ['database', 'server'];
            $i = 0;
            $all_file = basename($file_name[0]) . '|' . basename($file_name[1]);
            $all_size = intval($file_size[0] + $file_size[1]);
            $file_cloud_db = $cloudLink . '/' . get_host_edu() . '/backup' . "/$path_cloud[0]/" . basename($file_name[0]);
            $file_cloud_server = $cloudLink . '/' . get_host_edu() . '/backup' . "/$path_cloud[1]/" . basename($file_name[1]);
            $url_cloud = $file_cloud_db . '|' . $file_cloud_server;
            $file_db = $file_name[0];
            // Use for loop
            for ($i = 0; $i < count($file_name); $i++) {
                $file_upload = get_host_edu() . '/backup' . "/{$path_cloud[$i]}/" . basename($file_name[$i]);
                $url = $url_api[$i];
                $public_url = $cloudLink . '/' . $file_upload;

                $file_info = [
                    'name' => $all_file,
                    'size' => $file_size[$i],
                    'size_return' => $all_size,
                    'modified' => $file_created,
                    'url' => $public_url,
                    'url_cloud' => $url_cloud
                ];
                if ($all_size < $remain) {
                } else {
                    unlink($file_name[0]);
                    unlink($file_name[1]);
                    echo 'Storage 3 full';
                };
                $upload = check_key_ajax_function($file_upload, $url, $file_info, 'cloud_backup');
                if ($upload == 'Complete push up.' || $upload == NULL) {
                    $sql_cloud = "UPDATE $table_name SET file_check = 'cloud' WHERE file_path_db = '$file_db'";
                    if (connect()->query($sql_cloud)) {
                        echo 'add cloud success';
                    } else {
                        echo "Error: $sql_cloud " . mysqli_error(connect());
                    }
                } else {
                    unlink($file_name[0]);
                    unlink($file_name[1]);
                    wp_send_json_error('Storage 2 full');
                };
            };
            if ($upload == 'Complete push up.' || $upload == NULL) {
                unlink($file_name[0]);
                unlink($file_name[1]);
            };
            // function for_cloud($path_cloud, $file_name, $url_api, $all_file, $all_size, $public_url, $cloudLink, $file_size, $file_created, $i)
            // {
            //     $file_upload = get_host_edu() . '/backup' . "/{$path_cloud[$i]}/" . basename($file_name[$i]);
            //     $url = $url_api[$i];
            //     //$public_url = 'https://f005.backblazeb2.com/file/' . $bucket_name . '/' . $file_upload;
            //     $file_info = [
            //         'name' => $all_file,
            //         'size' => $file_size[$i],
            //         'size_return' => $all_size,
            //         'modified' => $file_created,
            //         'url' => $public_url
            //     ];
            //     check_key_ajax_function($file_upload, $url, $file_info, 'post_media_function');

            //     $count = count($file_name);
            //     $i++;
            //     if ($i < $count) {
            //         for_cloud($path_cloud, $file_name, $url_api, $all_file, $all_size, $public_url, $cloudLink, $file_size, $file_created, $i);
            //     }
            // }
            // for_cloud($path_cloud, $file_name, $url_api, $all_file, $all_size, $public_url, $cloudLink, $file_size, $file_created, $i);

            // unlink($file_name[0]);
            // unlink($file_name[1]);
            // $file_db = $file_name[0];
            $sql_cloud = "UPDATE $table_name SET file_check = 'cloud' WHERE file_path_db = '$file_db'";
            if (connect()->query($sql_cloud)) {
                echo 'add cloud success';
            } else {
                echo "Error: $sql_cloud " . mysqli_error(connect());
            }
            echo 'Success add to MySql';
        };
    } else {
        echo 'Get Api Key!!';
    };
}
add_action('wp_ajax_auto_backup', 'auto_backup');
add_action('wp_ajax_nopriv_auto_backup', 'auto_backup');
