<?php
include_once 'config.php';
include_once 'get_size.php';
global $wpdb;
$table = $wpdb->prefix . 'backup_edu';
$sql = "SELECT * FROM $table WHERE (file_check = 'local' OR file_check = 'cloud') AND file_path_server IS NOT NULL ORDER BY id DESC";
$result = mysqli_query(connect(), $sql);
$remain = remain_cloud();
$allow = allow_cloud();

if (get_option('md_edu_key')) {
	if (defined('DISABLE_WP_CRON') && DISABLE_WP_CRON === true) {
		$message = '<b>Cloud Edu2Work:</b> The DISABLE_WP_CRON constant is set to true. Auto Backup is disabled. Please set DISABLE_WP_CRON to false in "wp-config.php" to run Auto Backup daily.';
		$class = 'notice notice-warning is-dismissible';
		echo "<p class='$class p-2 m-2' style='font-family: sans-serif;'>$message</p>";
	}
}
?>

<center>

	<?php
	$size_server = get_directory_size(ABSPATH);
	$check_config = check_config();
	$php_ini = check_config()['compare'];
	$max_execution = check_config()['max_execution'];
	$post_maxsize = check_config()['post_maxsize'];
	$php_version = check_config()['php_version'];
	$size_limit = 200000000;
	?>
	<?php if ($php_ini || $max_execution < 300 || (convert_to_bytes($post_maxsize) < convert_to_bytes('200M'))) : ?>
		<div class='p-2 m-2 rounded-2 border border-danger div-show'>
			<?php if ($php_ini) :
				$warning = 'Your server is running PHP version: <span class="text-dark">' . $php_version . '</span>. Our plugins require PHP version "<span class="text-dark">>= 7.4</span>"';
			?>
				<p class="fs-6 text-danger">Warning: <?= $warning ?></p>
			<?php endif ?>
			<?php if ($max_execution < 300 || (convert_to_bytes($post_maxsize) < convert_to_bytes('200M'))) :
				if (($size_server > $size_limit)) :
					$notification = 'Server size too large. Please set <span class="text-dark p-2 rounded-2" style="font-family: Courier New, Courier, monospace; background: gainsboro;">max_execution_time >= 300</span> & <span class="text-dark p-2 rounded-2" style="font-family: Courier New, Courier, monospace; background: gainsboro;">post_max_size >= 200M</span> to run our plugins property.';
			?>
					<p class="fs-6 text-danger">Warning: <span class="text_dark"> <?= $notification ?></span></p>
				<?php else : ?>
					<input type="text" hidden id='showDiv' data-show='<?= $size_limit ?>'>
				<?php endif ?>
			<?php endif ?>
		</div>
	<?php endif ?>
	<?php
	$api_key = get_option('md_edu_key');
	if (!$api_key) { ?>
		<div class='my-4 p-4 border box-shadow bg-white'>
			<div>
				<p class='fs-4'>Enter your API Key to start <strong class="text-success">Auto Backup daily</strong> and <strong class="text-success">Upload to Cloud Free up to 2GB.</strong></p>
				<form method="post" action="" name="check_key" id="check_key">
					<div class="d-flex align-items-center justify-content-center">
						<div class="m-2">
							<label for="cloud-key" class="fs-5">Cloud API Key: </label>
							<input type="password" id="cloud-key" name='key' placeholder='Your API Key'>
						</div>
						<div>
							<button class="btn btn-success submit fw-bold d-flex align-items-center justify-content-center" style="width:100px" id='submit'>
								<p class="fs-6 m-1 send-confirm">Confirm</p>
								<div class='spinner-border text-light fs-6 spin-confirm' style="display: none;" role='status'>
									<span class='visually-hidden'>Loading...</span>
								</div>
							</button>
						</div>
					</div>
					<div class="m-2">
						<button class=" border-0 bg-transparent text-primary text-decoration-underline" id="forgot_button" data-bs-toggle="modal" data-bs-target="#forgot_Modal">For got your API Key?</button>
					</div>
					<div class="m-2 d-flex align-items-center justify-content-center">
						<p class="fs-5">You don't have API Key yet? Let's create it quickly!</p>
						<button type="button" class="m-2 p-2 btn btn-success rounded-2" id="new_account_button" data-bs-toggle="modal" data-bs-target="#Cr_Acc_Modal"> Create Now</button>
					</div>
					<!-- <?php
							// settings_fields('backup-plugin-settings');
							// do_settings_sections('backup-plugin-settings');
							// submit_button('Confirm');
							?> -->
				</form>
			</div>
			<div class="modal fade" id="forgot_Modal" tabindex="-1" data-bs-backdrop="static" aria-labelledby="forgot_Modal" aria-hidden="true">
				<div class="modal-dialog modal-dialog-centered">
					<div class="modal-content card">
						<div class="card-header text-center bg-primary text-white text-uppercase font-weight-bold h4 d-flex justify-content-between align-items-center">
							Your email is:
							<button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
						</div>
						<div class="form-group">
							<label for="email" class='fw-normal'></label>
							<input type="text" class="form-control" id="email" placeholder="example@gmail.com">
							<span id="reminderEmail"></span>
						</div>
						<div class="p-3">
							<button class="btn btn-primary submit fw-bold d-flex align-items-center justify-content-center" style="width: 33%;" id="submit_forgot" name="submit_forgot">
								<p class="fs-6 m-1 send-forgot">Send</p>
								<div class='spinner-border text-light ms-2 fs-6 spin-forgot' style="display: none;" role='status'>
									<span class='visually-hidden'>Loading...</span>
								</div>
							</button>

						</div>
					</div>
				</div>
			</div>
			<div class="modal fade" id="Verify_Modal" tabindex="-1" data-bs-backdrop="static" aria-labelledby="Verify_Modal" aria-hidden="true">
				<div class="modal-dialog modal-dialog-centered">
					<div class="modal-content card">
						<!-- <p class="fs-6 send-mail text-success">Email sent successfully, check your inbox!</p> -->
						<div class="card-header text-center bg-primary text-white text-uppercase font-weight-bold h4 d-flex justify-content-between align-items-center">
							Verify token is:
							<button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>

						</div>
						<div class="form-group">
							<label for="verify" class='fw-normal'></label>
							<input type="text" class="form-control" id="verify" placeholder="">
							<span id="reminderVerify"></span>
						</div>
						<div>
							<p class="fs-6 text-success">
								Please check your mail, Token has been sent!
							</p>
						</div>
						<div class="">
							<button class="btn btn-primary submit fw-bold d-flex align-items-center justify-content-center" id="submit_Verify" name="submit_Verify" style="width: 33%;">
								<p class="fs-6 m-1 send-verify">Send</p>
								<div class='spinner-border text-light ms-2 fs-6 spin-verify' style="display: none;" role='status'>
									<span class='visually-hidden'>Loading...</span>
								</div>
							</button>
						</div>
					</div>
				</div>
			</div>
			<div class="modal fade" id="Cr_Acc_Modal" tabindex="-1" data-bs-backdrop="static" aria-labelledby="Cr_Acc_Modal" aria-hidden="true">
				<div class="modal-dialog modal-dialog-centered">
					<div class="modal-content card">
						<div class="card-header text-center bg-primary text-white text-uppercase font-weight-bold h4 d-flex justify-content-between align-items-center">
							Sign up for account
							<button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>

						</div>
						<form id="form" class="card-body" method="post" enctype="multipart/form-data" runat="server">
							<div class="form-group my-2">
								<label for="Name" class='fw-normal'>Account name:</label>
								<input type="text" class="form-control" id="Name" placeholder="Empty">
								<span id="reminderName"></span>
							</div>
							<div class="form-group my-2">
								<label for="mail" class='fw-normal'>Email:</label>
								<input type="text" class="form-control" id="mail" placeholder="example@gmail.com">
								<span id="reminderMail"></span>
							</div>
							<div class="d-flex flex-nowrap my-2">
								<div class="form-group keep pb-2 header1 w-50">
									<label for="create" class='fw-normal'>Create password:</label>
									<input type="password" class="form-control" id="create" placeholder="Empty" required>
									<span class="show-btn"><i class="fa-solid fa-eye"></i></span>
									<span id="reminderCreate"></span>
								</div>
								<div class="form-group keep pb-2 header1 w-50 px-1">
									<label for="retry" class='fw-normal'>Retry password:</label>
									<input type="password" class="form-control" id="retry" placeholder="Empty" required>
									<span class="show-btn"><i class="fas fa-eye hide-btn"></i></span>
									<span id="reminderRetry"></span>
								</div>
							</div>
						</form>
						<div class="">

							<div>
								<button class="btn btn-primary submit fw-bold d-flex align-items-center justify-content-center" id="submit_sign" name="submit_sign" style="width: 33%;">
									<p class="fs-6 m-1 send-submit">Send</p>
									<div class='spinner-border text-light ms-2 fs-6 spin-submit' style="display: none;" role='status'>
										<span class='visually-hidden'>Loading...</span>
									</div>
								</button>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	<?php } ?>
	<div class='my-4 p-2 border box-shadow bg-white'>
		<div class="col-12">
			<div class="">
				<div class="text-center">
					<div>
						<button type="button" class="btn btn-primary p-2 my-4 text-center font-monospace" id="server">
							Backup Now
						</button>
					</div>
					<div class="m-2 p-2" id='handle' style='display:none;'>
						<div class="d-flex align-items-center justify-content-center m-2 p-2">
							<div class="spinner-border text-secondary" role="status" id='spin'>
								<span class="visually-hidden">Loading...</span>
							</div>
							<div>
								<h5 class="p-2 m-2 font-monospace">Request for backup</h5>
							</div>
						</div>

					</div>
					<div>
						<div class="progress-bar-container m-2" style='display:none'>
							<div class="progress-bar"></div>
						</div>
						<div class="get-zip p-2" style='display: none;'>
						</div>
					</div>
					<center>
						<div class="table-container">
							<div>
								<div class="reload-table">
									<?php if (@$result->num_rows > 0) : ?>
										<table class='col-12'>
											<thead class='thead'>
												<tr class='tr text-center font-monospace text-dark fw-bold'>
													<th class='p-2 col-2'>Date created</th>
													<th class='p-2 col-3'>Backup</th>
													<th class='p-2 col-1'>Size</th>
													<th class='p-2 col-1'>Status</th>
													<th class='p-2 col-5'>Action</th>
												</tr>
											</thead>
											<tbody class="tbody">
												<?php
												while ($row = mysqli_fetch_array($result)) {
													$file_size = explode(',', $row['file_size']);
													$size_mb = round(($file_size[0] + $file_size[1]) / (1024 * 1024), 1);
													if ($size_mb < 1024) {
														$size = $size_mb . ' MB';
													} else {
														$size = round($size_mb / 1024, 1) . ' GB';
													}
												?>
													<tr class='tr text-center font-monospace'>
														<td class="p-2"><?php echo $row["created_at"]; ?></td>
														<td class="p-2">
															<div class="d-flex justify-content-center">
																<?php if ($row['file_check'] == 'local') : ?>
																	<a href='<?= $row['file_download_server'] ?>' class="btn-light btn border border-success m-2 p-2 text-center font-monospace">
																		Download Server
																	</a>
																	<a href='<?= $row['file_download_db'] ?>' class="btn-light btn border border-success m-2 p-2 text-center font-monospace">
																		Download Database
																	</a>
																<?php else : ?>
																	<a href='<?= $row['file_cloud_server'] ?>' class="btn-light btn border border-success m-2 p-2 text-center font-monospace">
																		Download Server
																	</a>
																	<a href='<?= $row['file_cloud_db'] ?>' class="btn-light btn border border-success m-2 p-2 text-center font-monospace">
																		Download Database
																	</a>
																<?php endif ?>
															</div>
														</td>
														<td class='p-2'>
															<div>
																<?= $size ?>
															</div>
														</td>
														<td class='p-2'>
															<div>
																<?= $row['file_check'] ?>
															</div>
														</td>
														<td class="p-2">
															<div class=" d-flex ">
																<?php if ($row['file_check'] == 'local') : ?>
																	<button type="button" class="btn btn-light border m-2 border-primary p-2 text-center font-monospace restore" data-backup='<?= $row['file_path_server'] ?>'>
																		Restore Server
																	</button>
																	<button type="button" class="btn btn-light border m-2 border-primary p-2 text-center font-monospace database" data-backup='<?= $row['file_path_db'] ?>' data-delete='<?= $row['file_path_server'] ?>'>
																		Restore Database
																	</button>

																	<button type="button" class=" btn btn-light border m-2 border-primary p-2 text-center font-monospace <?= (@$remain > $allow) ? 'cloud' : 'local' ?>" data-path='<?= $row['file_path_db'] . ',' . $row['file_path_server']; ?>' data-api='<?= $row['file_download_db'] . ',' . $row['file_download_server']; ?>' data-size='<?= $row['file_size']; ?>' data-created='<?= $row['created_at']; ?>' data-token='<?= $api_key ?>'>
																		<div class='col-12'>
																			<p class="fs-6 cloud-api m-0">Upload Cloud</p>
																			<div style='width:100px; display:none' class='spin-api'>
																				<div class='spinner-border text-primary fs-4 ' role='status'>
																					<span class='visually-hidden'>Loading...</span>
																				</div>
																			</div>
																		</div>
																	</button>
																	<button type="button" class="btn btn-danger m-2  p-2 text-center font-monospace delete" data-id='<?= $row['id'] ?>'>
																		Delete Backup
																	</button>
																<?php else : ?>
																	<button type="button" class="btn btn-light border m-2 border-primary p-2 text-center font-monospace restore-cloud" data-backup='<?= $row['file_path_server']; ?>' data-cloud='<?= $row['file_cloud_server']; ?>'>
																		Restore Server
																	</button>
																	<button type="button" class="btn btn-light border m-2 border-primary p-2 text-center font-monospace database-cloud" data-backup='<?= $row['file_path_db']; ?>' data-cloud='<?= $row['file_cloud_db']; ?>' data-delete='<?= $row['file_path_server'] ?>'>
																		Restore Database
																	</button>
																	<!-- TODO: Delete this -->
																	<!-- <button type="button" class="btn btn-danger m-2  p-2 text-center font-monospace delete-cloud" data-id='<?= $row['id'] ?>'>
																		Delete Backup Cloud
																	</button> -->
																<?php endif ?>
															</div>
														</td>
													</tr>
												<?php
												}
												?>
											</tbody>
										</table>
									<?php else : ?>
										<div class="m-2 p-4 text-center rounded-2 border border-secondary font-monospace" id='message'>
											<h5>
												It appears that no backups have been created yet.
											</h5>
											<h5>
												Start creating Backup now...
											</h5>
										</div>
									<?php endif ?>
								</div>
								<div class='backup-content'>
									<div class='toggle-cloud'>
									</div>
									<div class="collapse collapse-cloud" id="collapseExample">
										<div class='domain-name d-flex justify-content-center'></div>
										<div class='table-cloud'>
										</div>
										<table class='col-12 mt-2'>
											<thead class='thead'>
												<tr class='tr text-center font-monospace text-dark fw-bold'>
													<th class="p-2 col-1">Website</th>
													<th class='p-2 col-1'>Date created</th>
													<th class='p-2 col-3'>Backup</th>
													<th class='p-2 col-1'>Size</th>
													<th class='p-2 col-1'>Status</th>
													<th class='p-2 col-4'>Action</th>
												</tr>
											</thead>
											<tbody class="tbody table-cloud-original">

											</tbody>
										</table>
									</div>
								</div>
							</div>
						</div>
					</center>
				</div>
			</div>
		</div>
	</div>
</center>
<div style="display: none;">
	<button type="button" class="btn btn-primary p-2 text-center" data-bs-toggle="modal" data-bs-target="#modalBackup" id='triggerModal'>
		Sync
	</button>
</div>
<!-- Modal -->
<div class="modal fade" id="modalBackup" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
	<div class="modal-dialog modal-dialog-centered">
		<div class="modal-content rounded-pill">
			<div class="modal-body text-center" id="scrollOver">
				<span class="fs-1 mb-4 text-success dashicons dashicons-yes-alt"></span>
				<h4 class='text-center text-success fw-bold font-monospace'>
					Backup created successfully.
				</h4>
			</div>
			<div class="modal-footer d-flex justify-content-center border-0">
				<div class="d-flex justify-content-center align-items-center btn btn-light" style="cursor: pointer;" data-bs-dismiss="modal">
					<div id=''>
						<i class="fs-4 pe-2 bi bi-x-octagon"></i>
					</div>
					<div class="font-monospace">
						Close
					</div>
				</div>
			</div>
		</div>
	</div>
</div>