<?php
function size_convert_edu($get_size)
{
    if ($get_size < 1024) {
        $size = $get_size . ' B';
    } elseif ($get_size < 1024 * 1024) {
        $size_kb = round($get_size / 1024, 1);
        $size = $size_kb . ' KB';
    } elseif ($get_size < 1024 * 1024 * 1024) {
        $size_mb = round($get_size / (1024 * 1024), 1);
        $size = $size_mb . ' MB';
    } else {
        $size_gb = round($get_size / (1024 * 1024 * 1024), 1);
        $size = $size_gb . ' GB';
    }
    return $size;
}

function convert_to_bytes($value)
{
    $value = trim($value);
    $unit = strtoupper($value[strlen($value) - 1]);
    $value = (int) $value;

    switch ($unit) {
        case 'G':
            $value *= 1024;
        case 'M':
            $value *= 1024;
        case 'K':
            $value *= 1024;
    }

    return $value;
}

function check_config()
{
    $max_execution = ini_get('max_execution_time');
    $post_maxsize = ini_get('post_max_size');
    $memory_limit = ini_get('memory_limit');
    $php_version = phpversion();
    $compare = version_compare($php_version, '7.4', '<');
    $init = [
        'max_execution' => $max_execution,
        'post_maxsize' => $post_maxsize,
        'memory_limit' => $memory_limit,
        'php_version' => $php_version,
        'compare' => $compare
    ];
    return $init;
}
