<?php
$api_key = get_option('md_edu_key');
$redirect_url = '';
if (!$api_key && isset($_GET['Token'])) {
    $redirect_url = remove_query_arg('Token', $_SERVER['REQUEST_URI']);
} else {
    $redirect_url = $_SERVER['REQUEST_URI'];
};

?>

<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Cloud Edu2Work</title>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <!-- Thư viện Bootstrap -->
    <style>
        .underline-button {
            text-decoration: underline;
            cursor: pointer;
            color: blue;
        }

        #wpwrap {
            background-color: #f6f6f6;
        }

        .box-shadow {
            box-shadow: 0 3px 3px rgba(0, 0, 0, .04);
        }
    </style>
</head>

<body class=''>
    <!-- <div style="height: 150px;"></div> -->
    <div class="wrap font-monospace">
        <div id='blur' class='font-monospace'>
            <center>
                <p class='fs-1'>Cloud Edu2Work</p>
                <div class="nav-tab-wrapper" id="myTab" role="tablist">
                    <a class="nav-tab nav-tab-active fs-6 font-monospace" href='#backup' id="backup-tab">Backup</a>
                    <?php if ($api_key) { ?>
                        <a class="nav-tab fs-6 font-monospace" href='#media' id="media-tab">Media Cloud</a>
                    <?php } ?>
                    <a class="nav-tab fs-6 font-monospace" href='#setting' id="setting-tab">Settings</a>
                    <a class="nav-tab fs-6 font-monospace" href='#clone' id="clone-tab">Clone Website</a>
                </div>
            </center>
            <div class="tab-content active" id="backup">
                <?php
                include_once 'backup.php';
                ?>
            </div>
            <?php if ($api_key) { ?>
                <div class="tab-content" id="media">
                    <?php
                    include_once 'mediaTab.php';
                    ?>
                </div>
            <?php } ?>
            <div class="tab-content" id="setting">
                <?php
                include_once 'setting.php';
                ?>
            </div>
            <div class="tab-content" id="clone">
                <?php
                include_once 'clone.php';
                ?>
            </div>
        </div>
        <div class="loading-restore" style='display: none;'>
            <div class="spinner-border text-primary fs-4 large-spin" style="z-index: 1111; position: absolute; right: 50%; top: 50%;" role="status">
                <span class="visually-hidden">Loading...</span>
            </div>
            <div class="font-monospace text-primary fw-bold" style="z-index: 1110; position: absolute; right: 40%; top: 60%;">
                <h4 class='restore-1'>Restoring the server... </h4>
                <h4 class='restore-2' style='display:none;'>Restoring Plugins... </h4>
                <h4 class='restore-3' style='display:none;'>Restoring Themes... </h4>
                <h4 class='restore-4' style='display:none;'>Restoring Uploads... </h4>
                <h4 class='restore-5' style='display:none;'>Restoring Other Files... </h4>
                <h4 class='database-restore' style='display:none;'>Restoring Database... </h4>

            </div>
        </div>
        <div class="overlay" style='display: none;'>
            <div class="overlay-content">
                <!-- Your content here -->
            </div>
        </div>
    </div>
    <script type="text/javascript">
        jQuery(document).ready(function($) {
            var api_key = '<?php echo $api_key; ?>';
            if (!api_key) {
                var urlParams = new URLSearchParams(window.location.search);
                var token = urlParams.get('Token');
                if (token) {
                    $.ajax({
                        url: "<?php echo admin_url('admin-ajax.php'); ?>",
                        method: "POST",
                        data: {
                            'action': 'verify_cloud',
                            'token': token
                        },
                        success: function(response) {

                            if (response.data == "Verified successfully!") {
                                var successMessage = response.data;
                                sessionStorage.setItem('successMessage', successMessage);
                            } else {
                                var errorMessage = response.data;
                                sessionStorage.setItem('errorMessage', errorMessage);
                            }
                            window.location.href = "<?php echo $redirect_url; ?>";
                        },
                        error: function(xhr, status, error) {
                            console.log(error);
                        }
                    });
                }
            } else {
                function get_size_cloud(size_mb) {
                    if (size_mb < 1024) {
                        size = size_mb + ' MB';
                    } else {
                        size = Math.round(size_mb / 1024, 1) + ' GB';
                    }
                    return size;
                }
                var backupShow = "";
                var toggleCloud = `<p>
										<a class="fs-6 text-decoration-none m-2 button-reverse" type="button" data-bs-toggle="collapse" data-bs-target="#collapseExample" aria-expanded="false" aria-controls="collapseExample">
											Show all your backup
											<i class="fas fa-chevron-down reverse-chevron"></i>
										</a>
									</p>`;

                $.ajax({
                    url: "<?php echo admin_url('admin-ajax.php'); ?>",
                    method: "POST",
                    data: {
                        'action': 'get_backup_file'
                    },
                    success: function(result) {
                        if (result.success) {
                            if (result.data.row[0]) {

                                var dir = result.data.dir;
                                var re = JSON.parse(result.data.row[0]['info']);
                                var row = result.data.row;
                                $('.toggle-cloud').append(toggleCloud);
                                $(".reverse-chevron").click(function() {
                                    $(this).toggleClass("fa-rotate-180");
                                });
                                var all = [];
                                var allDomain = [];
                                for (var i = 0; i < (row.length) / 2; i++) {
                                    var domain = row[i * 2]['domain'];
                                    allDomain.push(domain);
                                    var info = JSON.parse(row[i * 2]['info']);
                                    var file_name = info['name'];
                                    var url = info['url_cloud'];
                                    var create = info['modified'];
                                    // Handle file backup
                                    var file_path = info['name'].split('|');
                                    var file_path_db = dir + file_path[0];
                                    var file_path_server = dir + file_path[1];
                                    var cloud_url = info['url_cloud'].split('|');
                                    var cloud_url_db = cloud_url[0];
                                    var cloud_url_server = cloud_url[1];
                                    var sizeReturn = info['size_return'];
                                    var size_mb = (sizeReturn / (1024 * 1024)).toFixed(1);
                                    var size = get_size_cloud(size_mb);

                                    var allBackup = `<tr class='tr text-center font-monospace'>
													<td class="p-2">${domain}</td>
													<td class="p-2">${create}</td>
													<td class="p-2">
													<a href='${cloud_url_server}' class="btn-light btn border border-success m-2 p-2 text-center font-monospace">
													Download Server
															</a>
													<a href='${cloud_url_db}' class="btn-light btn border border-success m-2 p-2 text-center font-monospace">
													Download Database
															</a>
															</td>
													<td class="p-2">${size}</td>
													<td class="p-2">cloud</td>
													<td class="p-2">
													<div class="d-flex">
													<button type="button" class="btn btn-light border m-2 border-primary p-2 text-center font-monospace restore-api" data-backup='${file_path_server}' data-cloud='${cloud_url_server}' data-name='${domain}'>
													Restore Server
															</button>
													<button type="button" class="btn btn-light border m-2 border-primary p-2 text-center font-monospace database-api" data-backup='${file_path_db}' data-cloud='${cloud_url_db}' data-name='${domain}'>
													Restore Database
															</button>
															</div>
															</tr>`;
                                    $('.table-cloud-original').append(allBackup);
                                };
                                var uniqueDomain = [...new Set(allDomain)];
                                // 							for(var u = 0; u < uniqueDomain.length; u++){
                                // 								var domainId = uniqueDomain[u];
                                // 								var buttonClick = `<p>
                                // 													<button class="btn btn-success m-2" type="button" data-bs-toggle="collapse" data-bs-target="#${domainId}" aria-expanded="false" 														aria-controls="${domainId}">
                                // 													${domainId}
                                // 															</button>
                                // 													</p>`;
                                // 								$('.domain-name').append(buttonClick);
                                // 									var collapseTable = `<div class="collapse" id="${domainId}">
                                // 															<table class='col-12 mt-2'>
                                // 																<thead class='thead'>
                                // 																	<tr class='tr text-center font-monospace text-dark fw-bold'>
                                // 																		<th class="p-2 col-1">Website</th>
                                // 																		<th class='p-2 col-1'>Date created</th>
                                // 																		<th class='p-2 col-3'>Backup</th>
                                // 																		<th class='p-2 col-1'>Size</th>
                                // 																		<th class='p-2 col-1'>Status</th>
                                // 																		<th class='p-2 col-4'>Action</th>
                                // 																	</tr>
                                // 																</thead>
                                // 																<tbody class="tbody table-cloud-original"> 

                                // 																</tbody>
                                // 															</table>
                                // 														</div>`;
                                // // 								$('.table-cloud div#' + domainId).remove();
                                // 								$('.table-cloud').append(collapseTable);
                                // // 								row.sort(function(a, b) {
                                // // 									return a.domain.localeCompare(b.domain);
                                // // 								});
                                // 								for(var c = 0; c < (row.length)/2; c++){
                                // 									var checkDomain = row[c*2]['domain'];
                                // 									console.log(checkDomain, domainId);
                                // 									if(checkDomain === domainId){
                                // 										console.log('ok');

                                // 										var info = JSON.parse(row[c*2]['info']);
                                // 										var file_name = info['name'];
                                // 										var url = info['url']
                                // 										var create = info['modified'];
                                // 										// Handle file backup
                                // 										var file_path = info['name'].split(',');
                                // 										var file_path_db = dir + file_path[0];
                                // 										var file_path_server = dir + file_path[1];
                                // 										var cloud_url = info['url'].split(',');
                                // 										var cloud_url_db = cloud_url[0];
                                // 										var cloud_url_server = cloud_url[1];
                                // 										var sizeReturn = info['size_return'];
                                // 										var size_mb = Math.round(sizeReturn / 1000000, 1);
                                // 										var size = get_size_cloud(size_mb);
                                // 										var allBackup = `<tr class='tr text-center font-monospace'>
                                // 															<td class="p-2">${domain}</td>
                                // 															<td class="p-2">${create}</td>
                                // 															<td class="p-2">
                                // 															<a href='${cloud_url_server}' class="btn-light btn border border-success m-2 p-2 text-center font-monospace">
                                // 															Download Server
                                // 																	</a>
                                // 															<a href='${cloud_url_db}' class="btn-light btn border border-success m-2 p-2 text-center font-monospace">
                                // 															Download Database
                                // 																	</a>
                                // 																	</td>
                                // 															<td class="p-2">${size}</td>
                                // 															<td class="p-2">cloud</td>
                                // 															<td class="p-2">
                                // 															<div class="d-flex">
                                // 															<button type="button" class="btn btn-light border m-2 border-primary p-2 text-center font-monospace restore-cloud" data-backup='${file_path_server}' data-cloud='${cloud_url_server}'>
                                // 															Restore Server
                                // 																	</button>
                                // 															<button type="button" class="btn btn-light border m-2 border-primary p-2 text-center font-monospace database-cloud" data-backup='${file_path_db}' data-cloud='${cloud_url_db}'>
                                // 															Restore Database
                                // 																	</button>
                                // 																	</div>
                                // 															</tr>`;
                                // 										$('.table-cloud-original').append(allBackup);
                                // 									}
                                // 								}
                                // 							}
                            };
                        };
                    },
                });
                $('.toggle-cloud').on('click', '.button-reverse', function() {
                    $(this).find('.reverse-chevron').toggleClass('fa-rotate-180');
                });
            }
        });
    </script>
</body>

</html>