<?php
function backup_plugin_settings_init()
{
    add_settings_section(
        'backup-plugin-media-cloud-section',
        '',
        'backup_plugin_media_cloud_section_callback',
        'backup-plugin-settings'
    );
    $api_key = get_option('md_edu_key');
    if (!$api_key) {
        add_settings_field(
            'media-cloud-api-key',
            'Backup Cloud API Key',
            'backup_plugin_media_cloud_api_key_callback',
            'backup-plugin-settings',
            'backup-plugin-media-cloud-section'
        );

        add_settings_field(
            'media-cloud-new-account-button',
            '',
            'backup_plugin_media_cloud_new_account_button',
            'backup-plugin-settings',
            'backup-plugin-media-cloud-section'
        );
    }



}
add_action('admin_init', 'backup_plugin_settings_init');

function backup_plugin_media_cloud_section_callback()
{
echo "<h4 class='p-2'>Create token to use auto Backup and upload to Cloud</h4>";
}

function backup_plugin_media_cloud_api_key_callback()
{
	echo '<div class="form-group keep key-cloud" style="margin:1em 0 0 4em"><input type="password" name="md_edu_token" required value="" /><span class="show-btn eye-key"><i class="fas fa-eye hide-btn"></i></span><span class="m-2 underline-button d-flex justify-content-center" id="forgot_button" data-bs-toggle="modal" data-bs-target="#forgot_Modal">Forgot your API key?</span></div>';
}



function backup_plugin_media_cloud_new_account_button()
{

    echo '<span class="underline-button" id="new_account_button" data-bs-toggle="modal" data-bs-target="#Cr_Acc_Modal">You don\'t have key yet? Let\'s create it quickly!</span>';
}

function backup_plugin_register_settings()
{
    register_setting('backup-plugin-settings', 'media-cloud-api-key');
}
add_action('admin_init', 'backup_plugin_register_settings');

class BackupEdu2WorkView
{
    private $options;
    function __construct()
    {
        if (is_admin()) {
            add_action('admin_menu', array($this, 'add_page'));
            add_action('admin_init', array($this, 'init_page'));
        } else {
            add_action('init', array($this, 'create_page'));
            // add_action('init', array($this, 'init_page'));
        }
    }
    public function create_page()
    {
        $this->options = get_option('Backup_option');
        // var_dump(get_option('backup_option'));die;
        require_once BACKUP_PATH . 'settings/index.php';
    }

    public function add_page()
    {
        add_menu_page(
            'Cloud Edu2Work',
            'Cloud Edu2Work',
            'manage_options',
            'edu2work-admin',
            array($this, 'create_page'),
            'dashicons-backup',
            100
        );
    }
    public function sanitize($input)
    {
        $new_input = array();
        if (isset($input['user_key'])) {
            $new_input['user_key'] = sanitize_text_field($input['user_key']);
        }
        if (isset($input['active'])) {
            $new_input['active'] = sanitize_text_field($input['active']);
        }
        if (isset($input['draft'])) {
            $new_input['draft'] = sanitize_text_field($input['draft']);
        }
        if (isset($input['yt'])) {
            $new_input['yt'] = sanitize_text_field($input['yt']);
        }
        if (isset($input['show_yt'])) {
            $new_input['show_yt'] = sanitize_text_field($input['show_yt']);
        }
        if (isset($input['time'])) {
            $time = sanitize_text_field($input['time']);
            if ($time == '' || $time < 30) {
                $time = 30;
            }
            $new_input['time'] = $time;
        }
        if (isset($input['backup_type'])) {
            $backup_type = sanitize_text_field($input['backup_type']);
            if ($backup_type == '') {
                $backup_type = 'keyword';
            }
            $new_input['backup_type'] = $backup_type;
        }
        if (isset($input['local'])) {
            $new_input['local'] = sanitize_text_field($input['local']);
        }
        if (isset($input['user'])) {
            $user = sanitize_text_field($input['user']);
            if ($user == '') {
                $user = 1;
            }
            $new_input['user'] = $user;
        }
        if (isset($input['title_type'])) {
            $title_type = sanitize_text_field($input['title_type']);
            if ($title_type == '') {
                $title_type = 'source';
            }
            $new_input['title_type'] = $title_type;
        }
        if (isset($input['proxy'])) {
            $new_input['proxy'] = sanitize_text_field($input['proxy']);
        }
        if (isset($input['remove_domain'])) {
            $new_input['remove_domain'] = sanitize_text_field($input['remove_domain']);
        }
        if (isset($input['time_publish'])) {
            $time_publish = sanitize_text_field($input['time_publish']);
            if ($time_publish == '' || $time_publish < 0) {
                $time_publish = 0;
            }
            $new_input['time_publish'] = $time_publish;
        }
        if (isset($input['ping_time'])) {
            $ping_time = sanitize_text_field($input['ping_time']);
            if ($ping_time == '' || $ping_time < 300) {
                $ping_time = 900;
            }
            $new_input['ping_time'] = $ping_time;
        }
        if (isset($input['log'])) {
            $new_input['log'] = sanitize_text_field($input['log']);
        }

        return $new_input;
    }
    public function init_page()
    {
        register_setting(
            'Backup_option_group',
            'Backup_option',
            array($this, 'sanitize')
        );
        add_settings_section(
            'section_id',
            '',
            array($this, 'section_info'),
            'edu2work-admin'
        );
    }
    public function create_callback($args)
    {
    }
    public function section_info()
    {
    }
}
if (is_admin()) {
    new BackupEdu2WorkView();
}
